/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, runOn, delegateCombine, delegateRemove, EnumUtil, typeGetValue, enumGetBox, INotifyPropertyChanged_$type, PropertyChangedEventArgs, fromEn, fromEnum, typeCast, String_$type } from "igniteui-react-core";
import { INativeUIElementFactory_$type } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { XComponentBridge } from "igniteui-react-inputs";
import { INativeUIToolPanelBridge_$type } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-react-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolPanelOrientation_$type } from "./ToolPanelOrientation";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DOMExecutionContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { ListPanel } from "./ListPanel";
import { Popup } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { ToolActionType_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ToolActionEventDetail } from "./ToolActionEventDetail";
import { ToolCommandArgument } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolActionEventDetailCollection } from "./ToolActionEventDetailCollection";
import { ToolActionPerformedEventArgs } from "./ToolActionPerformedEventArgs";
import { ToolCommand } from "igniteui-react-core";
import { CSSColorUtil } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_, isPositiveInfinity, truncate, tryParseNumber } from "igniteui-react-core";
import { SvgIconRegistry } from "igniteui-react-core";
import { TooltipTextPresenter } from "./TooltipTextPresenter";
import { DelayManager } from "igniteui-react-core";
import { NativeUIWindow } from "igniteui-react-core";
import { NativeUIIconButton } from "igniteui-react-core";
import { BrushUtilCore } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ICommandStateChangedListener_$type } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ToolbarOrientation_$type } from "./ToolbarOrientation";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { NativeUIXInputsFactory } from "igniteui-react-inputs";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { Dictionary$2 } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { Queue$1 } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { MatrixTransform } from "igniteui-react-core";
/**
 * @hidden
 */
export let NativeUILayoutFactory = /*@__PURE__*/ (() => {
    class NativeUILayoutFactory extends Base {
        constructor() {
            super(...arguments);
            this.c = 2;
        }
        static get b() {
            if (NativeUILayoutFactory.a == null) {
                NativeUILayoutFactory.a = new NativeUILayoutFactory();
            }
            return NativeUILayoutFactory.a;
        }
        static e() {
            NativeUIComponent.ap(NativeUILayoutFactory.b);
        }
        get flavor() {
            return this.c;
        }
        createComponent(a, b, c) {
            switch (b) {
                case 13:
                    this.d(a, c);
                    break;
            }
        }
        createComponentSync(a, b, c) {
            this.createComponent(a, b, c);
        }
        supportsComponent(a) {
            switch (a) {
                case 13: return true;
            }
            return false;
        }
        d(a, b) {
            let c = a;
            let d = c.createElement("div");
            let e = c.getSubRenderer(d);
            let f = new ToolPanel();
            f.provideContainer(e);
            let g = new XToolPanelBridge(f);
            let h = new NativeUIToolPanel();
            h.al = d;
            h.d = g;
            b(h);
        }
    }
    NativeUILayoutFactory.$t = /*@__PURE__*/ markType(NativeUILayoutFactory, 'NativeUILayoutFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUILayoutFactory.a = null;
    return NativeUILayoutFactory;
})();
/**
 * @hidden
 */
export let XToolPanelBridge = /*@__PURE__*/ (() => {
    class XToolPanelBridge extends XComponentBridge {
        constructor(a) {
            super(a);
            this.u = null;
            this.x = null;
            this.v = null;
            this.y = null;
            this.w = null;
            this.z = null;
        }
        getDesiredSize(a, b) {
            return this.t.fl();
        }
        addHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 10:
                    e.drillDownRequested = delegateCombine(e.drillDownRequested, runOn(this, this.ab));
                    this.u = d;
                    this.x = b;
                    break;
                case 11:
                    e.drillUpRequested = delegateCombine(e.drillUpRequested, runOn(this, this.ac));
                    this.v = d;
                    this.y = b;
                    break;
                case 16:
                    e.onCommand = delegateCombine(e.onCommand, runOn(this, this.aa));
                    this.w = d;
                    this.z = b;
                    break;
            }
        }
        removeHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 10:
                    e.drillDownRequested = delegateRemove(e.drillDownRequested, runOn(this, this.ab));
                    this.u = null;
                    this.x = null;
                    break;
                case 11:
                    e.drillUpRequested = delegateRemove(e.drillUpRequested, runOn(this, this.ac));
                    this.v = null;
                    this.y = null;
                    break;
                case 16:
                    e.onCommand = delegateRemove(e.onCommand, runOn(this, this.aa));
                    this.w = null;
                    this.z = null;
                    break;
            }
        }
        ab(a, b) {
            if (this.u != null) {
                this.u(this.x, b);
            }
        }
        ac(a, b) {
            if (this.v != null) {
                this.v(this.y, b);
            }
        }
        aa(a, b) {
            if (this.w != null) {
                this.w(this.z, b);
            }
        }
        setValue(a, b, c) {
            let d = a;
            switch (b) {
                case 27:
                    d.actions = c;
                    break;
                case 30:
                    d.o = EnumUtil.getEnumValue(ToolPanelOrientation_$type, c);
                    break;
                case 28:
                    d.bn = typeGetValue(c);
                    break;
                case 18:
                    d.r = EnumUtil.getEnumValue(BaseControlTheme_$type, c);
                    break;
            }
        }
        getValue(a, b) {
            let c = a;
            switch (b) {
                case 27: return c.actions;
                case 30: return enumGetBox(ToolPanelOrientation_$type, c.o);
                case 28: return c.bn;
                case 29: return c.a2;
                case 18: return enumGetBox(BaseControlTheme_$type, c.r);
            }
            return null;
        }
        refresh(a) {
            a.dx();
        }
        notifySizeChanged(a, b) {
            a.notifySizeChanged();
        }
    }
    XToolPanelBridge.$t = /*@__PURE__*/ markType(XToolPanelBridge, 'XToolPanelBridge', XComponentBridge.$, [INativeUIToolPanelBridge_$type]);
    return XToolPanelBridge;
})();
/**
 * @hidden
 */
export let ToolbarView = /*@__PURE__*/ (() => {
    class ToolbarView extends Base {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.a = null;
            this.i = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.aa = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.j = null;
        }
        p() {
            return this.i;
        }
        v() {
        }
        t(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.a.b = new DOMExecutionContext(a);
            this.i = a;
            this.l = this.i.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
            this.k = this.i.createElement("div");
            this.y();
            let b = new ToolPanel();
            let c = this.i.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.i.append(c);
            let d = this.i.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.i.getExternal(b, this.i.rootWrapper, this.i.getExternal(this.a, null, null));
            this.a.b7(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.i.rootWrapper.setStyleProperty("position", "relative");
        }
        y() {
        }
        x() {
            if (this.i != null) {
            }
        }
        s() {
            if (this.i == null) {
                return;
            }
            let a = this.i.rootWrapper.width();
            let b = this.i.rootWrapper.height();
            this.aa = new Size(1, a, b);
            this.a.ca(this.aa);
        }
        z() {
            let a = this.i;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.p(b, this.a.c7);
                NativeUI.l(b, this.a.cy);
            }
        }
        d() {
            return this.b;
        }
        u() {
        }
        w() {
        }
        r() {
        }
        g() {
            return this.aa.width;
        }
        h(a) {
            this.c = this.a.u();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        q(a, b) {
            if (this.j == null) {
                this.j = this.i.createElement("div");
            }
            b(this.j.getNativeElement());
        }
    }
    ToolbarView.$t = /*@__PURE__*/ markType(ToolbarView, 'ToolbarView');
    return ToolbarView;
})();
/**
 * @hidden
 */
export let ToolPanelView = /*@__PURE__*/ (() => {
    class ToolPanelView extends Base {
        constructor() {
            super();
            this.s = null;
            this.r = null;
            this.c = null;
            this.n = null;
            this.q = null;
            this.g = null;
            this.p = null;
            this.d = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.ag = new Size();
            this.e = null;
            this._gridExternal = null;
            this.h = false;
            this.o = null;
        }
        v() {
            return this.n;
        }
        ab() {
        }
        get t() {
            return this.n.rootWrapper;
        }
        z(a) {
            if (a == null) {
                this.n = null;
                return;
            }
            this.c.a = new DOMExecutionContext(a);
            this.n = a;
            this.q = this.n.createElement("canvas");
            this.g = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
            this.p = this.n.createElement("div");
            this.ad();
            let b = new ListPanel();
            let c = this.n.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.n.append(c);
            let d = this.n.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            b.externalListPanel = e;
            this.c.di(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.n.rootWrapper.setStyleProperty("position", "relative");
            this.n.rootWrapper.setStyleProperty("width", "100%");
        }
        ad() {
        }
        y() {
            if (this.n == null) {
                return;
            }
            let a = this.n.rootWrapper.width();
            let b = this.n.rootWrapper.height();
            this.ag = new Size(1, a, b);
            this.c.dn(this.ag);
            if (this.c.v != null) {
            }
        }
        k() {
            let a = this.n.rootWrapper.getNativeElement();
            return a.offsetWidth;
        }
        j() {
            let a = this.n.rootWrapper.getNativeElement();
            return a.offsetHeight;
        }
        ae() {
            let a = this.n;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.p(b, this.c.fi);
                NativeUI.l(b, this.c.e8);
            }
        }
        f() {
            return this.d;
        }
        aa() {
        }
        ac() {
        }
        x() {
        }
        i() {
            return this.ag.width;
        }
        l(a) {
            this.e = this.c.u();
            return FontUtil.measureStringWidth(a, this.e, this.g);
        }
        m(a, b) {
            return FontUtil.measureStringWidth(a, b, this.g);
        }
        w(a, b) {
            if (this.o == null) {
                this.o = this.n.createElement("div");
            }
            b(this.o.getNativeElement());
        }
        a() {
            let a = new Popup();
            let b = this.n.getExternal(a, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            return a;
        }
        b(a) {
            let b = new ToolPanel();
            let c = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            let d = a.al;
            d.appendChild(b.p.n.rootWrapper.getNativeElement());
            return b;
        }
        af(a) {
            let ele_ = a;
            let bounds_ = (ele_.getBoundingClientRect());
            let b = bounds_["left"];
            let c = bounds_["top"];
            let d = bounds_["width"];
            let e = bounds_["height"];
            return new Rect(0, b, c, d, e);
        }
    }
    ToolPanelView.$t = /*@__PURE__*/ markType(ToolPanelView, 'ToolPanelView');
    return ToolPanelView;
})();
/**
 * @hidden
 */
export let NativeUIToolPanel = /*@__PURE__*/ (() => {
    class NativeUIToolPanel extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bl = null;
            this.bg = null;
            this.bh = null;
            this.bn = null;
        }
        get bk() {
            return this.d;
        }
        get bp() {
            return this.ae(27);
        }
        set bp(a) {
            this.a0(27, a);
        }
        get bs() {
            return this.ae(28);
        }
        set bs(a) {
            this.a0(28, a);
        }
        get br() {
            return this.ae(29);
        }
        get bq() {
            return EnumUtil.getEnumValue(ToolPanelOrientation_$type, this.ae(30));
        }
        set bq(a) {
            this.a0(30, enumGetBox(ToolPanelOrientation_$type, a));
        }
        get b1() {
            return this.ae(33);
        }
        set b1(a) {
            this.a0(33, a);
        }
        get bw() {
            return this.ae(34);
        }
        set bw(a) {
            this.a0(34, a);
        }
        get bv() {
            return this.ae(23);
        }
        set bv(a) {
            this.a0(23, a);
        }
        get b0() {
            return this.ae(50);
        }
        set b0(a) {
            this.a0(50, a);
        }
        get bx() {
            return this.ae(51);
        }
        set bx(a) {
            this.a0(51, a);
        }
        get by() {
            return this.ae(52);
        }
        set by(a) {
            this.a0(52, a);
        }
        get bz() {
            return this.ae(53);
        }
        set bz(a) {
            this.a0(53, a);
        }
        get bm() {
            return this.bl;
        }
        set bm(a) {
            let b = this.bl;
            this.bl = a;
            if (this.bl != null) {
                this.an(9, this.bl);
            }
            else {
                this.ay(9, b);
            }
        }
        get bi() {
            return this.bg;
        }
        set bi(a) {
            let b = this.bg;
            this.bg = a;
            if (this.bg != null) {
                this.an(10, this.bg);
            }
            else {
                this.ay(10, b);
            }
        }
        get bj() {
            return this.bh;
        }
        set bj(a) {
            let b = this.bh;
            this.bh = a;
            if (this.bh != null) {
                this.an(11, this.bh);
            }
            else {
                this.ay(11, b);
            }
        }
        get bo() {
            return this.bn;
        }
        set bo(a) {
            let b = this.bn;
            this.bn = a;
            if (this.bn != null) {
                this.an(16, this.bn);
            }
            else {
                this.ay(16, b);
            }
        }
        bu() {
            this.bk.refresh(this.ak);
        }
        bt(a) {
            this.bk.notifySizeChanged(this.ak, a);
        }
    }
    NativeUIToolPanel.$t = /*@__PURE__*/ markType(NativeUIToolPanel, 'NativeUIToolPanel', NativeUIComponent.$);
    return NativeUIToolPanel;
})();
/**
 * @hidden
 */
export let ToolAction = /*@__PURE__*/ (() => {
    class ToolAction extends Base {
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.d1("ExecutionContext", b, this.a);
            }
        }
        get cw() {
            if (this.cy != null) {
                return this.cy;
            }
            if (this.de != null) {
                return this.c9(this.de);
            }
            return null;
        }
        get actions() {
            return this.e;
        }
        get bl() {
            return this.a3;
        }
        set bl(a) {
            this.a3 = a;
        }
        constructor() {
            super();
            this.j = null;
            this.a = null;
            this.d = null;
            this.e = new ToolActionCollection();
            this.a3 = NaN;
            this.bv = null;
            this.cc = null;
            this.b9 = null;
            this.c0 = null;
            this.br = null;
            this.bq = null;
            this.bm = null;
            this.k = 0;
            this.az = NaN;
            this.ar = NaN;
            this.a0 = NaN;
            this.as = NaN;
            this.ay = NaN;
            this.aq = NaN;
            this.a1 = NaN;
            this.at = NaN;
            this.eh = null;
            this.eo = null;
            this.em = BrushUtil.g(0, 0, 0, 0);
            this.ef = null;
            this.el = null;
            this.ek = null;
            this.er = null;
            this.eg = null;
            this.en = null;
            this.o = null;
            this.q = null;
            this.ac = false;
            this.bu = null;
            this.bx = null;
            this.bw = null;
            this.a2 = 30;
            this.bt = null;
            this.bs = null;
            this.av = NaN;
            this.aw = NaN;
            this.ax = NaN;
            this.au = NaN;
            this.ep = null;
            this.ei = null;
            this.eq = null;
            this.ej = null;
            this.e4 = 0;
            this.ab = false;
            this.propertyChanged = null;
            this.p = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.onCommand = null;
            this.performed = null;
            this.x = null;
            this.w = null;
            this.u = null;
            this.z = null;
            this.aa = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.du));
            let b = this.actions;
            b.collectionResetting = delegateCombine(b.collectionResetting, runOn(this, this.dv));
        }
        dh() {
        }
        du(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    c.dh();
                    c.d = null;
                }
            }
            if (b.newItems != null) {
                for (let d of fromEn(b.newItems)) {
                    d.d = this;
                }
            }
        }
        dv(a, b) {
            for (let c of fromEnum(this.actions)) {
                c.dh();
                c.d = null;
            }
        }
        c9(a) {
            return stringReplace(a, " ", "_");
        }
        g(a) {
            return ((() => {
                let $ret = new ToolActionEventDetail();
                $ret.g = this.cw;
                $ret.a = this.m;
                $ret.c = a;
                return $ret;
            })());
        }
        n() {
            return ((() => {
                let $ret = new ToolCommandArgument();
                $ret.argumentName = this.c7();
                $ret.value = this.bo();
                return $ret;
            })());
        }
        c7() {
            if (this.ce != null) {
                return this.ce;
            }
            return this.cw != null ? this.cw : "Unknown";
        }
        bo() {
            if (this.bn != null) {
                return this.bn;
            }
            return this.bp();
        }
        bp() {
            return null;
        }
        get c5() {
            return this.bv;
        }
        set c5(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.d1("ParentId", b, this.bv);
            }
        }
        c8() {
            if (this.ch != null) {
                return this.ch;
            }
            return this.cw;
        }
        get ch() {
            return this.br;
        }
        set ch(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.d1("CommandId", b, this.br);
            }
        }
        get ce() {
            return this.bq;
        }
        set ce(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.d1("CommandArgument", b, this.bq);
            }
        }
        get bn() {
            return this.bm;
        }
        set bn(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.d1("CommandArgumentValue", b, this.bm);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.d1("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get bh() {
            return this.az;
        }
        set bh(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.d1("PaddingLeft", b, this.az);
            }
        }
        get a5() {
            return this.ar;
        }
        set a5(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.d1("ActualPaddingLeft", b, this.ar);
            }
        }
        get bi() {
            return this.a0;
        }
        set bi(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.d1("PaddingRight", b, this.a0);
            }
        }
        get a6() {
            return this.as;
        }
        set a6(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.d1("ActualPaddingRight", b, this.as);
            }
        }
        get bg() {
            return this.ay;
        }
        set bg(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.d1("PaddingBottom", b, this.ay);
            }
        }
        get a4() {
            return this.aq;
        }
        set a4(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.d1("ActualPaddingBottom", b, this.aq);
            }
        }
        get bj() {
            return this.a1;
        }
        set bj(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.d1("PaddingTop", b, this.a1);
            }
        }
        get a7() {
            return this.at;
        }
        set a7(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.d1("ActualPaddingTop", b, this.at);
            }
        }
        get eu() {
            return this.eh;
        }
        set eu(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.d1("ActualHoverBackground", b, this.eh);
            }
        }
        get e0() {
            return this.eo;
        }
        set e0(a) {
            let b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.d1("HoverBackground", b, this.eo);
            }
        }
        get es() {
            return this.ef;
        }
        set es(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.d1("ActualBackground", b, this.ef);
            }
        }
        get ey() {
            return this.el;
        }
        set ey(a) {
            let b = this.el;
            this.el = a;
            if (b != this.el) {
                this.d1("Background", b, this.el);
            }
        }
        get ex() {
            return this.ek;
        }
        set ex(a) {
            let b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.d1("ActualTextColor", b, this.ek);
            }
        }
        get e3() {
            return this.er;
        }
        set e3(a) {
            let b = this.er;
            this.er = a;
            if (b != this.er) {
                this.d1("TextColor", b, this.er);
            }
        }
        get et() {
            return this.eg;
        }
        set et(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.d1("ActualDisabledTextColor", b, this.eg);
            }
        }
        get ez() {
            return this.en;
        }
        set ez(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.d1("DisabledTextColor", b, this.en);
            }
        }
        get r() {
            return this.o;
        }
        set r(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.d1("ActualTextStyle", b, this.o);
            }
        }
        get t() {
            return this.q;
        }
        set t(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.d1("TextStyle", b, this.q);
            }
        }
        get aj() {
            return this.ac;
        }
        set aj(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.d1("IsDisabled", b, this.ac);
            }
        }
        get ai() {
            return this.c5 != null;
        }
        get cy() {
            return this.bu;
        }
        set cy(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.d1("Name", b, this.bu);
            }
        }
        get de() {
            return this.bx;
        }
        set de(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.d1("Title", b, this.bx);
            }
        }
        get da() {
            return this.bw;
        }
        set da(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.d1("Subtitle", b, this.bw);
            }
        }
        get bk() {
            return this.a2;
        }
        set bk(a) {
            this.a2 = a;
        }
        get cp() {
            return this.bt;
        }
        set cp(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.d1("IconName", b, this.bt);
            }
        }
        get cm() {
            return this.bs;
        }
        set cm(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.d1("IconCollectionName", b, this.bs);
            }
        }
        get bd() {
            return this.av;
        }
        set bd(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.d1("IconViewBoxLeft", b, this.av);
            }
        }
        get be() {
            return this.aw;
        }
        set be(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.d1("IconViewBoxTop", b, this.aw);
            }
        }
        get bf() {
            return this.ax;
        }
        set bf(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.d1("IconViewBoxWidth", b, this.ax);
            }
        }
        get bc() {
            return this.au;
        }
        set bc(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.d1("IconViewBoxHeight", b, this.au);
            }
        }
        get e1() {
            return this.ep;
        }
        set e1(a) {
            let b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.d1("IconFill", b, this.ep);
            }
        }
        get ev() {
            return this.ei;
        }
        set ev(a) {
            let b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.d1("ActualIconFill", b, this.ei);
            }
        }
        get e2() {
            return this.eq;
        }
        set e2(a) {
            let b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.d1("IconStroke", b, this.eq);
            }
        }
        get ew() {
            return this.ej;
        }
        set ew(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.d1("ActualIconStroke", b, this.ej);
            }
        }
        get e5() {
            return this.e4;
        }
        set e5(a) {
            let b = this.e4;
            this.e4 = a;
            if (b != this.e4) {
                this.d1("Visibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.e4));
            }
        }
        get ae() {
            return this.ab;
        }
        set ae(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.d1("CloseOnExecute", b, this.ab);
            }
        }
        get_af() {
            return true;
        }
        get af() {
            return this.get_af();
        }
        get_ag() {
            return true;
        }
        get ag() {
            return this.get_ag();
        }
        get_al() {
            return true;
        }
        get al() {
            return this.get_al();
        }
        get_an() {
            return true;
        }
        get an() {
            return this.get_an();
        }
        get_ad() {
            return true;
        }
        get ad() {
            return this.get_ad();
        }
        d1(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.d8(a, b, c);
        }
        get_m() {
            return 0;
        }
        get m() {
            return this.get_m();
        }
        d8(a, b, c) {
            switch (a) {
                case "Background":
                case "TextColor":
                case "TextStyle":
                    this.ed();
                    break;
                case "ActualBackground":
                    if (this.y != null) {
                        this.y.a4 = this.es;
                    }
                    break;
                case "ActualTextColor":
                    if (this.aa != null) {
                        this.aa.a6 = this.ex;
                    }
                    break;
                case "ActualTextStyle":
                    if (this.aa != null) {
                        this.aa.bg = this.r;
                    }
                    break;
                case "IsDisabled":
                    if (this.aa != null) {
                        this.aa.a6 = this.aj ? this.et : this.ex;
                    }
                    break;
                case "ActualIconFill":
                case "ActualIconStroke":
                    if (this.z != null) {
                        this.z.a7 = this.ev;
                        this.z.a8 = this.ew;
                    }
                    break;
                case "Visibility":
                    if (this.j != null) {
                        this.j.dy();
                    }
                    break;
                case "IconName":
                case "IconCollectionName":
                    this.d0();
                    break;
            }
        }
        ak() {
            return this.j != null && this.j.bo != null && typeCast(Toolbar.$, this.j.bo) !== null;
        }
        ed() {
            if (this.j == null) {
                return;
            }
            this.l = this.j.r;
            this.es = this.ey != null ? this.ey : this.em;
            this.ex = this.e3 != null ? this.e3 : this.j.e5;
            this.et = this.ez != null ? this.ez : this.j.ew;
            this.eu = this.e0 != null ? this.e0 : this.j.e0;
            this.ev = this.e1 != null ? this.e1 : this.j.e1;
            this.ew = this.e2 != null ? this.e2 : this.j.e2;
            this.r = this.t != null ? this.t : this.p;
            this.a5 = !isNaN_(this.bh) ? this.bh : DeviceUtils.g(12);
            this.a6 = !isNaN_(this.bi) ? this.bi : DeviceUtils.g(12);
            this.a7 = !isNaN_(this.bj) ? this.bj : DeviceUtils.g(2);
            this.a4 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(2);
            this.ee();
        }
        ee() {
        }
        d0() {
            if (this.z != null) {
                this.z.bl = this.cp;
                this.z.bk = this.cm;
            }
        }
        d3(a, b, c, d) {
            this.ds(c.b, c, d, (e) => {
                this.di(c.b);
                this.x = e;
                this.dr(c.b, this.x, d, () => {
                    c.b.bo = this.x;
                    this.eb(this.w, this.z, this.aa);
                    this.d5(this.w == null ? this.x : this.w, c, d);
                });
            });
        }
        d5(a, b, c) {
        }
        d4(a, b, c, d) {
        }
        dm(a, b) {
            this.dn(a, b);
        }
        dn(a, b) {
            b.f = this.a9(a, b);
            b.h = this.bb(a, b);
            b.g = this.ba(a, b);
            b.b = this.a8(a, b);
            if (b.a == 1) {
                let c = 0;
                if (!isNaN_(b.f)) {
                    c += b.f;
                }
                if (!isNaN_(b.h)) {
                    c += b.h;
                }
                if (!isNaN_(b.g)) {
                    c += b.g;
                }
                if (!isNaN_(b.b)) {
                    c += b.b;
                }
                c += (this.a5 + this.a6);
                b.e = c;
            }
            else {
                if (!isNaN_(this.bl)) {
                    b.e = this.bl;
                }
                else {
                    let d = 0;
                    if (!isNaN_(b.f)) {
                        d += b.f;
                    }
                    if (!isNaN_(b.h)) {
                        d += b.h;
                    }
                    if (!isNaN_(b.g)) {
                        d += b.g;
                    }
                    if (!isNaN_(b.b)) {
                        d += b.b;
                    }
                    d += (this.a5 + this.a6);
                    if (isNaN_(b.c) || isPositiveInfinity(b.c) || d > b.c) {
                        b.e = d;
                    }
                    else {
                        b.e = b.c;
                    }
                }
            }
        }
        ba(a, b) {
            return NaN;
        }
        bb(a, b) {
            if (this.de == null) {
                return NaN;
            }
            let c = this.s(a);
            let d = a.p.m(this.de, c);
            return d + this.bk;
        }
        a9(a, b) {
            if (!stringIsNullOrEmpty(this.cp)) {
                return DeviceUtils.g(36);
            }
            return NaN;
        }
        s(a) {
            return a.u();
        }
        a8(a, b) {
            return NaN;
        }
        d2(a, b) {
            this.d9();
            if (this.ai) {
                let c = this.j.f(this.c5);
                if (c != null) {
                    c.dx(this, this.ae);
                }
            }
            else {
                if (this.j.ab(this)) {
                    if (this.performed != null) {
                        let d = new ToolActionEventDetailCollection();
                        this.dl(this, d, b);
                        this.performed(this, ((() => {
                            let $ret = new ToolActionPerformedEventArgs();
                            $ret.c = true;
                            $ret.b = d;
                            return $ret;
                        })()));
                    }
                }
                else {
                    if (this.performed != null) {
                        this.performed(this, ((() => {
                            let $ret = new ToolActionPerformedEventArgs();
                            $ret.c = false;
                            $ret.a = a;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        d9() {
            let a = this.c8();
            if (a == null) {
                return;
            }
            let b = new ToolCommand();
            b.commandId = a;
            let c = new List$1(ToolCommandArgument.$, 0);
            this.dk(this, c);
            b.argumentsList = c.toArray();
            let d = ((() => {
                let $ret = new ToolCommandEventArgs();
                $ret.a = b;
                $ret.b = this.ae;
                return $ret;
            })());
            if (this.onCommand != null) {
                this.onCommand(this, d);
            }
            if (this.j != null) {
                this.j.dq(this, d);
            }
        }
        ea(a) {
            let b = ((() => {
                let $ret = new ToolCommandEventArgs();
                $ret.a = a;
                $ret.b = this.ae;
                return $ret;
            })());
            if (this.onCommand != null) {
                this.onCommand(this, b);
            }
            if (this.j != null) {
                this.j.dq(this, b);
            }
        }
        ao() {
            return this.onCommand != null;
        }
        dk(a, b) {
            let c = a.n();
            if (c != null) {
                b.add(c);
            }
            let d = this.j.ag(a);
            if (d != null) {
                for (let e = 0; e < d.count; e++) {
                    if (d._inner[e].ah()) {
                        this.dk(d._inner[e], b);
                    }
                }
            }
        }
        ah() {
            return true;
        }
        dx(a, b) {
            if (this.ai) {
                let c = this.j.f(this.c5);
                if (c != null) {
                    c.dx(a, b);
                }
            }
            else {
                this.d2(this.g(false), a);
                if (b) {
                    this.dj();
                }
            }
        }
        dl(a, b, c) {
            let d = a.g(a == c);
            b.add(d);
            let e = this.j.ag(a);
            if (e != null) {
                for (let f = 0; f < e.count; f++) {
                    this.dl(e._inner[f], b, c);
                }
            }
        }
        static c(a) {
            let b = null;
            switch (a.b) {
                case 2:
                    b = new ToolActionCheckbox();
                    break;
                case 1:
                    b = new ToolActionGroupHeader();
                    break;
                case 3:
                    b = new ToolActionIconButton();
                    break;
                case 4:
                    b = new ToolActionLabel();
                    break;
                case 5:
                    b = new ToolActionNumberInput();
                    break;
                case 6:
                    b = new ToolActionRadio();
                    break;
                case 7:
                    b = new ToolActionSeparator();
                    break;
                case 8:
                    b = new ToolActionIconMenu();
                    break;
                case 9:
                    b = new ToolActionButton();
                    break;
                case 0: return null;
            }
            b.dt(a);
            return b;
        }
        dt(a) {
            this.cy = a.name;
            this.de = a.title;
            this.ce = a.commandArgument;
            this.bn = a.commandArgumentValue;
            this.ch = a.commandId;
            this.cp = a.iconName;
            this.cm = a.iconCollectionName;
            this.bd = a.iconViewBoxLeft;
            this.be = a.iconViewBoxTop;
            this.bf = a.iconViewBoxWidth;
            this.bc = a.iconViewBoxHeight;
            this.bh = a.paddingLeft;
            this.bi = a.paddingRight;
            this.bj = a.paddingTop;
            this.bg = a.paddingBottom;
            this.c5 = a.parentId;
            this.aj = a.isDisabled;
            this.ae = a.closeOnExecute;
            if (!stringIsNullOrEmpty(a.textColor)) {
                this.e3 = CSSColorUtil.a(a.textColor);
            }
            if (!stringIsNullOrEmpty(a.disabledTextColor)) {
                this.ez = CSSColorUtil.a(a.disabledTextColor);
            }
            if (a.actions != null && a.actions.length > 0) {
                for (let b = 0; b < a.actions.length; b++) {
                    this.actions.add(ToolAction.c(a.actions[b]));
                }
            }
        }
        am() {
            return this.d != null && this.d.d != null && this.d.actions._inner[0] == this;
        }
        ap() {
            return true;
        }
        v(a) {
            switch (a) {
                case 1:
                case 6:
                case 11:
                case 10:
                case 2:
                case 12:
                case 13: return this.ap() ? 2 : 0;
                default: return 0;
            }
        }
        get y() {
            return this.x;
        }
        ds(a, b, c, d) {
            if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                NativeUIComponent.ar(this.j.p.v(), 7, (e) => {
                    let f = e;
                    this.dq(f, c);
                    this.ec(f, b, c);
                    if (d != null) {
                        d(f);
                    }
                });
            }
            else {
                let e = a.bo;
                this.ec(e, b, c);
                if (d != null) {
                    d(e);
                }
            }
        }
        dr(a, b, c, d) {
            if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                let e = [1, 7, 11, 3];
                let f = [this.v(1), this.v(7), this.v(11), this.v(3)];
                NativeUIComponent.as(this.j.p.v(), e, f, (g) => {
                    let h = g[0];
                    let i = g[1];
                    let j = g[2];
                    let k = g[3];
                    this.dp(h, i, j, k, c);
                    if (d != null) {
                        d();
                    }
                });
            }
            else {
                this.eb(this.w, this.z, this.aa);
                if (d != null) {
                    d();
                }
            }
        }
        dq(a, b) {
            a.f = b.a == 1 ? 0 : 3;
            a.bo = 0;
        }
        ec(a, b, c) {
            a.x = b.a.k;
            a.a4 = this.es;
            a.bf = this.e5;
        }
        dp(a, b, c, d, e) {
            if (this.x.bi == 0) {
                this.x.bw(0, 2, 1);
                this.x.by(0, 2, 1);
                this.x.bj(a);
                this.x.b3(a, 0);
                this.x.b4(a, 0);
                a.bj = b;
                b.bo = 0;
                let f = this.a9(this.j, e);
                f = isNaN_(f) ? 0 : f;
                let g = this.bb(this.j, e);
                g = isNaN_(g) ? 0 : g - this.bk;
                b.by(0, 2, 1);
                b.bw(0, 1, f);
                b.bw(1, 1, g);
                b.bx(2, 2, 1, this.bk);
                b.bj(c);
                b.bj(d);
                b.b4(d, 0);
                b.b3(c, 0);
                b.b3(d, 1);
            }
            a.c = this.l;
            a.bk = 1;
            a.bi = 1;
            a.bu = new Thickness(1, 0, 0, 0, 0);
            a.g = 3;
            a.i = 3;
            a.bt = this.eu;
            a.bq = true;
            a.bo = !this.af;
            a.bl = this.ad;
            a.bn = !this.ag;
            a.bp = true;
            a.bm = true;
            a.bh = runOn(this, this.dw);
            c.h = 1;
            c.f = 1;
            d.bh = false;
            d.h = 1;
            d.f = 0;
            this.w = b;
            this.u = a;
            this.z = c;
            this.aa = d;
        }
        dw(a, b) {
            this.dz();
        }
        eb(a, b, c) {
            if (a != null) {
                a.be = new Thickness(1, this.a5, this.a7, this.a6, this.a4);
            }
            if (b != null) {
                b.bd = new Thickness(1, 0, 0, 9, 0);
                b.bh = this.bd;
                b.bi = this.be;
                b.bj = this.bf;
                b.bg = this.bc;
                b.bl = this.cp;
                b.bk = this.cm;
                b.a7 = this.ev;
                b.a8 = this.ew;
                b.ad = 28;
                b.x = 28;
            }
            if (c != null) {
                c.bi = this.de;
                c.bg = this.r;
                c.a6 = this.aj ? this.et : this.ex;
            }
        }
        di(a) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (this.x != null) {
                    this.x.bq = null;
                }
            }
        }
        dz() {
        }
        dy(a, b) {
        }
        d6() {
        }
        dj() {
        }
        d7(a) {
            if (!stringIsNullOrEmpty(a.de)) {
                this.de = a.de;
            }
            if (!stringIsNullOrEmpty(a.da)) {
                this.da = a.da;
            }
            if (!stringIsNullOrEmpty(a.cp)) {
                this.cp = a.cp;
            }
            if (!stringIsNullOrEmpty(a.cm)) {
                this.cm = a.cm;
            }
            if (!stringIsNullOrEmpty(a.ch)) {
                this.ch = a.ch;
            }
            if (!stringIsNullOrEmpty(a.ce)) {
                this.ce = a.ce;
            }
            if (a.bn != null) {
                this.bn = a.bn;
            }
            if (a.ey != null) {
                this.ey = a.ey;
            }
            if (a.e0 != null) {
                this.e0 = a.e0;
            }
            if (a.e3 != null) {
                this.e3 = a.e3;
            }
            if (a.t != null) {
                this.t = a.t;
            }
            if (a.ez != null) {
                this.ez = a.ez;
            }
            if (a.e1 != null) {
                this.e1 = a.e1;
            }
            if (a.e2 != null) {
                this.e2 = a.e2;
            }
            if (!isNaN_(a.bh)) {
                this.bh = a.bh;
            }
            if (!isNaN_(a.bj)) {
                this.bj = a.bj;
            }
            if (!isNaN_(a.bi)) {
                this.bi = a.bi;
            }
            if (!isNaN_(a.bg)) {
                this.bg = a.bg;
            }
            if (!isNaN_(a.bl)) {
                this.bl = a.bl;
            }
            if (this.e5 != a.e5) {
                this.e5 = a.e5;
            }
            if (a.actions != null && a.actions.count > 0) {
                this.actions.clear();
                for (let b = 0; b < a.actions.count; b++) {
                    this.actions.add(a.actions._inner[b]);
                }
            }
        }
    }
    ToolAction.$t = /*@__PURE__*/ markType(ToolAction, 'ToolAction', Base.$, [INotifyPropertyChanged_$type]);
    return ToolAction;
})();
/**
 * @hidden
 */
export let ToolActionButton = /*@__PURE__*/ (() => {
    class ToolActionButton extends ToolAction {
        constructor() {
            super(...arguments);
            this.e6 = null;
        }
        get_m() {
            return 9;
        }
        n() {
            return null;
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.g = this.cw;
            b.a = this.m;
            b.c = a;
            return b;
        }
        bb(a, b) {
            return NaN;
        }
        ba(a, b) {
            return 88;
        }
        e8(a, b, c, d, e, f, g) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                a.bo = b;
                if (g.a == 1) {
                    b.f = 0;
                }
                else {
                    b.f = 3;
                }
                b.by(0, 2, 1);
                b.bw(0, 0, 1);
                b.be = new Thickness(1, this.a5, this.a7, this.a6, this.a4);
                if (b.bi == 0) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 0);
                this.e6 = c;
                this.e6.bk = 2;
                this.e6.bh = runOn(this, this.e7);
            }
            c.bs = this.de;
            b.x = f.a.k;
        }
        e7(a, b) {
            this.d2(this.g(true), this);
        }
        d4(a, b, c, d) {
            super.d4(a, b, c, d);
            let e = c.b;
            if (e.bo == null || (e.am == null || EnumUtil.getEnumValue(ToolActionType_$type, e.am) != this.m)) {
                let f = [7, 1];
                let g = [0, 0];
                if (this.l >= 3 && this.l <= 6) {
                    g = [0, 2];
                }
                NativeUIComponent.as(b.p.v(), f, g, (h) => {
                    let i = h[0];
                    let j = h[1];
                    e.bo = i;
                    this.e8(e, i, j, a, b, c, d);
                });
                e.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let h = e.bo;
                let i = h.bh(0);
                this.e8(e, h, i, a, b, c, d);
            }
        }
    }
    ToolActionButton.$t = /*@__PURE__*/ markType(ToolActionButton, 'ToolActionButton', ToolAction.$);
    return ToolActionButton;
})();
/**
 * @hidden
 */
export let ToolActionLabel = /*@__PURE__*/ (() => {
    class ToolActionLabel extends ToolAction {
        get_af() {
            return this.ao() || this.actions.count > 0;
        }
        constructor() {
            super();
            this.e6 = null;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarDrillDownIcon") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarDrillDownIcon", ToolActionLabel.e7);
            }
        }
        get_m() {
            return 4;
        }
        ba(a, b) {
            return this.actions.count > 0 ? DeviceUtils.g(32) : super.ba(a, b);
        }
        e8(a, b, c, d) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (b.bi == 2) {
                    let e = this.ba(this.j, d);
                    b.bw(3, 1, isNaN_(e) ? 0 : e);
                    b.bj(c);
                    b.b3(c, 3);
                    b.b4(c, 0);
                    c.bl = "ToolbarDrillDownIcon";
                    c.bk = "IG_Default";
                    c.f = 1;
                    c.h = 1;
                }
            }
            c.a7 = this.ex;
        }
        dz() {
            if (this.actions.count > 0) {
                this.j.dz(this);
            }
            else {
                this.d2(this.g(false), this);
            }
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                if (this.actions.count > 0) {
                    NativeUIComponent.aq(this.j.p.v(), 11, this.ap() ? 2 : 0, (e) => {
                        this.e6 = e;
                        this.e8(d, a, this.e6, c);
                    });
                }
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                if (this.actions.count > 0) {
                    this.e6 = a.bh(2);
                    this.e8(d, a, this.e6, c);
                }
            }
        }
        d8(a, b, c) {
            super.d8(a, b, c);
            switch (a) {
                case "ActualTextColor":
                    if (this.e6 != null) {
                        this.e6.a6 = this.ex;
                    }
                    break;
            }
        }
    }
    ToolActionLabel.$t = /*@__PURE__*/ markType(ToolActionLabel, 'ToolActionLabel', ToolAction.$);
    ToolActionLabel.e7 = "M 7.42 8.58 L 12 13.17 L 7.42 17.76 L 8.83 19.17 l 6 -6 l -6 -6 z";
    return ToolActionLabel;
})();
/**
 * @hidden
 */
export let ToolActionRadio = /*@__PURE__*/ (() => {
    class ToolActionRadio extends ToolAction {
        constructor() {
            super(...arguments);
            this.e6 = null;
            this.e9 = "channel_1";
            this.e7 = false;
        }
        get_m() {
            return 6;
        }
        get fa() {
            return this.e9;
        }
        set fa(a) {
            this.e9 = a;
        }
        get e8() {
            return this.e7;
        }
        set e8(a) {
            let b = this.e7;
            this.e7 = a;
            if (b != this.e7) {
                this.d1("IsChecked", b, this.e7);
            }
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.g = this.cw;
            b.a = this.m;
            b.c = a;
            if (this.e6 != null) {
                b.b = this.e6.bj;
            }
            return b;
        }
        bp() {
            return this.e6.bj;
        }
        fc() {
            if (this.e6 != null) {
                this.e6.bj = false;
                this.e7 = this.e6.bj;
            }
        }
        ba(a, b) {
            return 30;
        }
        ee() {
            if (this.e6 != null) {
                this.e6.c = this.l;
            }
        }
        dz() {
            this.e6.bj = true;
            this.e7 = this.e6.bj;
            this.d2(this.g(true), this);
        }
        fd(a, b) {
            if (this.e7) {
                this.e6.bj = true;
                return;
            }
            this.e7 = this.e6.bj;
            this.d2(this.g(true), this);
        }
        fe(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                b.bw(3, 1, this.ba(this.j, e));
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                this.e6 = c;
                c.bi = true;
                c.f = 1;
                c.h = 1;
                c.bk = DeviceUtils.g(10);
                c.ad = DeviceUtils.g(20);
                c.x = DeviceUtils.g(20);
                c.bh = runOn(this, this.fd);
                a.am = enumGetBox(ToolActionType_$type, this.m);
            }
            this.e6.bj = this.e7;
            this.e6.c = this.l;
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                NativeUIComponent.aq(this.j.p.v(), 6, this.v(6), (e) => {
                    let f = e;
                    this.fe(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(2);
                this.fe(d, a, e, b, c);
            }
        }
        d8(a, b, c) {
            super.d8(a, b, c);
            switch (a) {
                case "IsChecked":
                    if (this.e6 != null) {
                        this.e6.bj = this.e8;
                    }
                    break;
            }
        }
        dt(a) {
            super.dt(a);
            let b = a;
            this.e8 = b.isChecked;
            this.fa = b.channel;
        }
    }
    ToolActionRadio.$t = /*@__PURE__*/ markType(ToolActionRadio, 'ToolActionRadio', ToolAction.$);
    return ToolActionRadio;
})();
/**
 * @hidden
 */
export let ToolActionSeparator = /*@__PURE__*/ (() => {
    class ToolActionSeparator extends ToolAction {
        get e9() {
            return this.e8;
        }
        set e9(a) {
            let b = this.e8;
            this.e8 = a;
            if (b != this.e8) {
                this.d1("Size", b, this.e8);
            }
        }
        get e7() {
            return this.e6;
        }
        set e7(a) {
            let b = this.e6;
            this.e6 = a;
            if (b != this.e6) {
                this.d1("IsGroupHeaderSeparator", b, this.e6);
            }
        }
        constructor() {
            super();
            this.e8 = DeviceUtils.g(2);
            this.e6 = false;
        }
        get_m() {
            return 7;
        }
        dn(a, b) {
            super.dn(a, b);
            if (b.a == 1) {
                b.e = this.a5 + this.e9 + this.a6;
            }
            else {
                b.d = this.a7 + this.e9 + this.a4;
            }
        }
        dr(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        dq(a, b) {
            if (b.a == 1) {
                a.f = 0;
                a.h = 3;
            }
            else {
                a.f = 3;
            }
        }
        ec(a, b, c) {
            if (c.a == 1) {
                a.ad = this.e9;
            }
            else {
                a.x = this.e9;
            }
            a.bd = new Thickness(1, this.a5, this.a7, this.a6, this.a4);
            a.a4 = this.es;
            a.bf = this.e5;
        }
        ee() {
            super.ee();
            this.es = this.ey != null ? this.ey : !this.e7 ? this.j.e3 : this.j.ey;
            if (this.j.o == 1) {
                this.a5 = !isNaN_(this.bh) ? this.bh : this.j.a4;
                this.a6 = !isNaN_(this.bi) ? this.bi : this.j.a5;
                this.a7 = !isNaN_(this.bj) ? this.bj : this.j.a6;
                this.a4 = !isNaN_(this.bg) ? this.bg : this.j.a3;
            }
            else {
                if (this.d == null && this.ak()) {
                    this.a5 = !isNaN_(this.bh) ? this.bh : DeviceUtils.g(10);
                    this.a6 = !isNaN_(this.bi) ? this.bi : DeviceUtils.g(10);
                }
                else {
                    this.a5 = !isNaN_(this.bh) ? this.bh : this.j.a8;
                    this.a6 = !isNaN_(this.bi) ? this.bi : this.j.a9;
                }
                this.a7 = !isNaN_(this.bj) ? this.bj : this.j.ba;
                this.a4 = !isNaN_(this.bg) ? this.bg : this.j.a7;
            }
        }
        d8(a, b, c) {
            super.d8(a, b, c);
            switch (a) {
                case "Size":
                    if (this.j != null) {
                        this.j.dy();
                    }
                    break;
                case "IsGroupHeaderSeparator":
                    this.ed();
                    break;
            }
        }
        dt(a) {
            super.dt(a);
            let b = a;
            this.e9 = b.size;
            this.e7 = b.isGroupHeaderSeparator;
        }
    }
    ToolActionSeparator.$t = /*@__PURE__*/ markType(ToolActionSeparator, 'ToolActionSeparator', ToolAction.$);
    return ToolActionSeparator;
})();
/**
 * @hidden
 */
export let ToolActionIconButton = /*@__PURE__*/ (() => {
    class ToolActionIconButton extends ToolAction {
        get_m() {
            return 3;
        }
        get_an() {
            return false;
        }
        get fc() {
            return this.fb;
        }
        get_fk() {
            return this.e7 != null;
        }
        get fk() {
            return this.get_fk();
        }
        get fj() {
            return this.fg;
        }
        set fj(a) {
            this.fg = a;
        }
        get fo() {
            return this.fn;
        }
        set fo(a) {
            this.fn = a;
        }
        constructor() {
            super();
            this.fb = null;
            this.e7 = null;
            this.e6 = null;
            this.fl = -1;
            this.fm = -1;
            this.fh = false;
            this.fe = false;
            this.fd = false;
            this.fg = false;
            this.fn = 500;
            this.fi = false;
            this.e8 = null;
            this.fa = null;
            this.e9 = null;
            this.ff = false;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "igDropDownArrow") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "igDropDownArrow", "M0,0L3,3L6,0");
            }
            this.e6 = new DelayManager(0);
        }
        dh() {
            super.dh();
            NativeUIWindow.f(14, runOn(this, this.f4));
            this.fd = false;
        }
        n() {
            return null;
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.g = this.cw;
            b.a = this.m;
            b.c = a;
            return b;
        }
        a9(a, b) {
            return DeviceUtils.g(36);
        }
        bb(a, b) {
            return NaN;
        }
        dr(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        di(a) {
            super.di(a);
        }
        f6(a, b, c, d, e) {
            let f = c.bj;
            if (e) {
                b.b1(2);
                b.b1(1);
                if (b.bi == 0) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 0);
                c.c = this.l;
                c.bk = 2;
                c.bi = 4;
                c.bp = true;
                f.ad = DeviceUtils.g(28);
                f.x = DeviceUtils.g(28);
            }
            b.br = false;
            b.be = new Thickness(1, this.a5, this.a7, this.a6, this.a4);
            f.bl = this.cp;
            f.bk = this.cm;
            f.bh = this.bd;
            f.bi = this.be;
            f.bj = this.bf;
            f.bg = this.bc;
            f.a7 = this.ex;
            f.a8 = this.ex;
            if (this.e8 != c) {
                c.bh = runOn(this, this.fv);
                c.q = runOn(this, this.fx);
                c.s = runOn(this, this.fy);
                c.o = runOn(this, this.fw);
                this.e8 = c;
            }
            if (this.fa != f) {
                this.fa = f;
            }
        }
        f7(a, b) {
            if (this.fb != b) {
                this.fb = b;
                this.fb.b1 = this.j.bb;
                this.fb.b9 = BrushUtil.g(255, 255, 255, 255);
                this.fb.bo = 1;
                this.fb.bx = true;
                this.fb.b3 = 100;
                this.fb.bv = true;
                this.fb.b4 = truncate(this.j.bc);
                this.fb.by = true;
                if (a.bi != 2) {
                    a.bj(this.fb);
                }
                this.fq();
                this.fb.q = runOn(this, this.f2);
                this.fb.s = runOn(this, this.f3);
                this.fb.n = runOn(this, this.f0);
                this.fb.o = runOn(this, this.f1);
                if (!this.fd) {
                    NativeUIWindow.e(14, runOn(this, this.f4));
                    this.fd = true;
                }
            }
            if (this.actions.count > 0) {
                this.fb.u = true;
            }
            else {
                this.fb.u = false;
            }
        }
        fq() {
            if (this.fb.bi == 0) {
                this.e7 = new TooltipTextPresenter(this.j.p.v());
                this.e7.s(() => this.fb.bj(this.e7.e));
            }
            else {
                this.e7 = this.fb.bh(0).am;
            }
            this.e7.x = this.j.e6;
            this.e7.y = this.j.e7;
            this.e7.o = this.de;
            this.fb.ca = this.e7.x;
        }
        fs() {
        }
        fr() {
        }
        ft() {
            if (this.e7 != null) {
                this.fb.ca = this.j.e6;
                this.e7.x = this.j.e6;
                this.e7.y = this.j.e7;
                this.fb.b1 = this.j.bb;
                this.fb.b4 = truncate(this.j.bc);
            }
        }
        f8() {
            if (this.e7 != null) {
                return this.e7.z();
            }
            return Size.empty;
        }
        f4() {
            if (this.e8 != null) {
                let a = this.e8.ba();
                this.fb.b7(a);
            }
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                NativeUIComponent.as(this.j.p.v(), [10, 12], [this.v(10), this.v(12)], (e) => {
                    this.f6(d, a, e[0], c, true);
                    this.f7(a, e[1]);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(0);
                let f = a.bh(1);
                this.f6(d, a, e, c, false);
                this.f7(a, f);
            }
        }
        ee() {
            super.ee();
            this.a5 = !isNaN_(this.bh) ? this.bh : DeviceUtils.g(4);
            this.a6 = !isNaN_(this.bi) ? this.bi : DeviceUtils.g(4);
            if (this.e8 != null) {
                this.e8.c = this.l;
                if (typeCast(NativeUIIconButton.$, this.e8) !== null) {
                    this.e8.a7 = this.ex;
                    this.e8.a8 = this.ex;
                }
            }
            if (this.fa != null) {
                this.fa.a7 = this.ex;
                this.fa.a8 = this.ex;
            }
            if (this.e9 != null) {
                this.e9.a8 = this.ex;
            }
            this.ft();
        }
        d0() {
            if (this.fa != null) {
                this.fa.bl = this.cp;
                this.fa.bk = this.cm;
            }
        }
        d6() {
            if (this.actions.count > 0) {
                if (this.fb == null || !this.fk) {
                    this.fg = true;
                }
                else {
                    this.f5();
                    this.fh = true;
                }
            }
        }
        dj() {
            if (this.actions.count > 0) {
                if (this.fb == null || !this.fk) {
                    this.fg = false;
                }
                else {
                    this.fp();
                }
            }
        }
        f5(a = false) {
            if (!this.fi) {
                this.j.dd();
                if (this.actions.count == 0 && stringIsNullOrEmpty(this.de)) {
                    return;
                }
                let b = this.e8.ba();
                if (this.j.o == 1) {
                    let c = NativeUIWindow.c();
                    let d = this.f8();
                    d.height += this.fb.b2;
                    if (b.bottom + d.height > c) {
                        if (b.top - d.height < 0) {
                            this.fb.b8(b, 1, 3);
                        }
                        else {
                            this.fb.b8(b, 2, 3);
                        }
                    }
                    else {
                        this.fb.b8(b, 1, 3);
                    }
                }
                else {
                    let e = NativeUIWindow.d();
                    let f = this.f8();
                    f.width += this.fb.b2;
                    if (b.right + f.width > e) {
                        if (b.left - f.width < 0) {
                            this.fb.b8(b, 4, 3);
                        }
                        else {
                            this.fb.b8(b, 3, 3);
                        }
                    }
                    else {
                        this.fb.b8(b, 4, 3);
                    }
                }
                this.fi = true;
                this.fs();
            }
            this.fh = a;
            this.fg = false;
        }
        fp() {
            if (this.fi) {
                this.fb.b5();
                this.fi = false;
                this.e6.f(() => this.fr(), 100);
                this.fh = false;
            }
        }
        fz() {
            this.f5();
            this.fm = -1;
        }
        fu() {
            this.fp();
            this.fl = -1;
        }
        fx(a, b) {
            this.fe = true;
            if (this.fl != -1) {
                this.e6.g(this.fl);
                this.fl = -1;
            }
            if (!this.fi) {
                if (this.actions.count > 0 && !this.j.ac) {
                    return;
                }
                this.fm = this.e6.f(runOn(this, this.fz), this.fo);
            }
        }
        fy(a, b) {
            if (this.fm != -1) {
                this.e6.g(this.fm);
                this.fm = -1;
            }
            if (this.fi && !this.fh) {
                this.fl = this.e6.f(runOn(this, this.fu), 50);
            }
            this.fe = false;
        }
        fv(a, b) {
            if (this.actions.count > 0) {
                if (!this.fi) {
                    if (this.fm != -1) {
                        this.e6.g(this.fm);
                        this.fm = -1;
                    }
                    this.f5();
                    this.fh = true;
                }
                else {
                    this.fp();
                }
            }
            else {
                this.d2(this.g(true), this);
            }
        }
        f2(a, b) {
            this.ff = true;
            if (this.fl != -1) {
                this.e6.g(this.fl);
                this.fl = -1;
            }
        }
        f3(a, b) {
            if (!this.fh) {
                this.fl = this.e6.f(runOn(this, this.fu), 50);
            }
            this.ff = false;
        }
        f0(a, b) {
            this.fh = true;
        }
        f1(a, b) {
            if (!this.fb.t(b.a) && !this.e8.t(b.a)) {
                this.fp();
            }
        }
        fw(a, b) {
            if (this.fi) {
                if (!this.fb.t(b.a) && !this.e8.t(b.a)) {
                    this.fp();
                }
            }
        }
        d8(a, b, c) {
            super.d8(a, b, c);
            switch (a) {
                case "ExecutionContext":
                    this.e6.b = this.b;
                    break;
                case "Title":
                    if (this.e7 != null) {
                        this.e7.o = this.de;
                    }
                    break;
            }
        }
        dt(a) {
            super.dt(a);
            let b = a;
            this.fo = b.tooltipDelay;
            if (b.isMenuOpenOnStart) {
                this.d6();
            }
        }
    }
    ToolActionIconButton.$t = /*@__PURE__*/ markType(ToolActionIconButton, 'ToolActionIconButton', ToolAction.$);
    return ToolActionIconButton;
})();
/**
 * @hidden
 */
export let ToolActionGroupHeader = /*@__PURE__*/ (() => {
    class ToolActionGroupHeader extends ToolAction {
        get_m() {
            return 1;
        }
        get_af() {
            return false;
        }
        get_ag() {
            return false;
        }
        get_al() {
            return false;
        }
        get ff() {
            return this.fd;
        }
        set ff(a) {
            let b = this.fd;
            this.fd = a;
            if (b != this.fd) {
                this.d1("ActualBackIconColor", b, this.fd);
            }
        }
        get fg() {
            return this.fe;
        }
        set fg(a) {
            let b = this.fe;
            this.fe = a;
            if (b != this.fe) {
                this.d1("BackIconColor", b, this.fe);
            }
        }
        constructor() {
            super();
            this.e6 = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Bold";
                $ret.o = "Normal";
                return $ret;
            })());
            this.e7 = null;
            this.fd = null;
            this.fe = null;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarBackButton") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarBackButton", ToolActionGroupHeader.e9);
            }
        }
        s(a) {
            return this.e6;
        }
        a8(a, b) {
            return this.am() ? DeviceUtils.g(36) : NaN;
        }
        fc(a, b, c, d) {
            let e = c.bj;
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (b.bi == 2) {
                    b.bj(c);
                    b.bz(0, 1, this.a8(this.j, d));
                    b.b3(b.bh(0), 1);
                    b.b3(b.bh(1), 2);
                    b.b3(c, 0);
                    b.b4(c, 0);
                    c.c = this.l;
                    c.h = 1;
                    c.f = 1;
                    c.bd = new Thickness(1, -9, 0, 9, 0);
                    c.bh = runOn(this, this.fb);
                    this.e7 = c;
                    e.bl = "ToolbarBackButton";
                    e.bk = "IG_Default";
                }
            }
            e.a7 = this.ff;
        }
        fb(a, b) {
            this.j.d0(this);
        }
        di(a) {
            super.di(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (this.am() && this.e7 != null) {
                    this.e7.bh = null;
                }
            }
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                if (this.am()) {
                    NativeUIComponent.aq(this.j.p.v(), 10, this.ap() ? 2 : 0, (e) => this.fc(d, a, e, c));
                }
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                if (this.am()) {
                    let e = a.bh(2);
                    this.fc(d, a, e, c);
                }
            }
        }
        ee() {
            super.ee();
            if (this.e7 != null) {
                this.e7.c = this.l;
            }
            this.es = this.ey != null ? this.ey : this.j.ex;
            this.ex = this.e3 != null ? this.e3 : this.j.ez;
            this.ff = this.fg != null ? this.fg : this.ex;
            this.r = this.t != null ? this.t : this.e6;
        }
    }
    ToolActionGroupHeader.$t = /*@__PURE__*/ markType(ToolActionGroupHeader, 'ToolActionGroupHeader', ToolAction.$);
    ToolActionGroupHeader.e9 = "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z";
    return ToolActionGroupHeader;
})();
/**
 * @hidden
 */
export let ToolActionIconMenu = /*@__PURE__*/ (() => {
    class ToolActionIconMenu extends ToolActionIconButton {
        constructor() {
            super(...arguments);
            this.f9 = null;
        }
        get_m() {
            return 8;
        }
        get_fk() {
            return this.f9 != null;
        }
        fq() {
            if (this.fc.bi > 0) {
                while (this.fc.bi > 0) {
                    this.fc.bm(0);
                }
            }
            if (this.f9 != null) {
                this.f9.s = null;
            }
            this.f9 = new ToolPanelsPresenter(this.j.p.v(), this.b);
            this.f9.n = this.l;
            this.f9.ai(() => {
                this.f9.ae(this, (a) => {
                    this.f9.aj(a);
                    if (this.actions._inner[0].es != null && !BrushUtilCore.a(this.actions._inner[0].es)) {
                        this.fc.ca = this.actions._inner[0].es;
                    }
                    else {
                        this.fc.ca = this.j.e4;
                    }
                    if (this.fj) {
                        this.b.executeDelayed(() => this.f5(true), 100);
                    }
                });
                this.f9.r.a3 = new CornerRadius(0, 8);
                this.f9.r.a4 = this.j.e4;
                this.fc.bj(this.f9.r);
            });
            this.f9.s = runOn(this, this.ga);
        }
        fs() {
            if (this.f9 != null) {
                this.f9.am();
            }
        }
        fr() {
            if (this.f9 != null) {
                this.f9.aw();
                this.fc.b6();
            }
        }
        ft() {
            if (this.f9 != null) {
                this.f9.ax(this.l, this.j);
                if (this.actions._inner[0].es != null && !BrushUtilCore.a(this.actions._inner[0].es)) {
                    this.fc.ca = this.actions._inner[0].es;
                }
                else {
                    this.fc.ca = this.j.e4;
                }
                this.fc.b1 = 8;
                this.fc.b4 = 4;
            }
        }
        f8() {
            return this.f9.a2();
        }
        gb(a, b, c, d, e, f, g) {
            if (g) {
                a.b1(2);
                a.b1(1);
                if (a.bi == 0) {
                    c.bw(0, 1, DeviceUtils.g(28));
                    c.bw(1, 1, DeviceUtils.g(6));
                    c.bj(d);
                    c.bj(e);
                    c.b3(d, 0);
                    c.b3(e, 1);
                    b.bj = c;
                    a.bj(b);
                }
                a.b4(b, 0);
                a.b3(b, 0);
                b.c = this.l;
                b.bk = 2;
                b.bi = 4;
                b.bp = true;
                d.ad = DeviceUtils.g(28);
                d.x = DeviceUtils.g(28);
                d.h = 1;
                e.ad = DeviceUtils.g(6);
                e.x = DeviceUtils.g(3);
                e.h = 1;
                e.bd = new Thickness(1, -4, 0, 0, 0);
                e.bl = "igDropDownArrow";
                e.bk = "IG_Default";
                e.bh = 0;
                e.bi = 0;
                e.bj = 6;
                e.bg = 3;
                e.a7 = BrushUtil.g(0, 0, 0, 0);
                e.ab = DeviceUtils.g(1);
            }
            a.br = false;
            a.be = new Thickness(1, this.a5, this.a7, this.a6, this.a4);
            d.bl = this.cp;
            d.bk = this.cm;
            d.bh = this.bd;
            d.bi = this.be;
            d.bj = this.bf;
            d.bg = this.bc;
            d.a7 = this.ex;
            d.a8 = this.ex;
            e.a8 = this.ex;
            if (this.e8 != b) {
                b.bh = runOn(this, this.fv);
                b.q = runOn(this, this.fx);
                b.s = runOn(this, this.fy);
                b.o = runOn(this, this.fw);
                this.e8 = b;
            }
            if (this.fa != d) {
                this.fa = d;
            }
            if (this.e9 != e) {
                this.e9 = e;
            }
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                let e = [1, 7, 11, 11, 12];
                let f = [this.v(1), this.v(7), this.v(11), this.v(11), this.v(12)];
                NativeUIComponent.as(this.j.p.v(), e, f, (g) => {
                    this.gb(a, g[0], g[1], g[2], g[3], c, true);
                    this.f7(a, g[4]);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let g = a.bh(0);
                let h = g.bj;
                let i = h.bh(0);
                let j = h.bh(1);
                let k = a.bh(1);
                this.gb(a, g, h, i, j, c, false);
                this.f7(a, k);
            }
        }
        ga(a) {
            this.ea(a.a);
            if (a.b) {
                this.dj();
            }
        }
    }
    ToolActionIconMenu.$t = /*@__PURE__*/ markType(ToolActionIconMenu, 'ToolActionIconMenu', ToolActionIconButton.$);
    return ToolActionIconMenu;
})();
/**
 * @hidden
 */
export let ToolActionCheckbox = /*@__PURE__*/ (() => {
    class ToolActionCheckbox extends ToolAction {
        constructor() {
            super(...arguments);
            this.e6 = null;
            this.e7 = false;
        }
        get_m() {
            return 2;
        }
        get_ad() {
            return false;
        }
        get e8() {
            return this.e7;
        }
        set e8(a) {
            let b = this.e7;
            this.e7 = a;
            if (b != this.e7) {
                this.d1("IsChecked", b, this.e7);
            }
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.g = this.cw;
            b.a = this.m;
            b.c = a;
            if (this.e6 != null) {
                b.b = this.e6.bj;
            }
            return b;
        }
        bp() {
            return this.e6.bj;
        }
        ba(a, b) {
            return DeviceUtils.g(32);
        }
        di(a) {
            super.di(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (this.e6 != null) {
                    this.e6.bh = null;
                }
            }
        }
        dz() {
            this.e6.bj = !this.e6.bj;
            this.e7 = this.e6.bj;
            this.d2(this.g(true), this);
        }
        fb(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                b.bw(3, 1, this.ba(this.j, e));
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                this.e6 = c;
                c.bi = true;
                c.f = 1;
                c.h = 1;
                c.ad = DeviceUtils.g(20);
                c.x = DeviceUtils.g(20);
                c.bh = runOn(this, this.fa);
            }
            this.e6.bj = this.e7;
            this.e6.c = this.l;
        }
        fa(a, b) {
            this.e7 = this.e6.bj;
            this.d2(this.g(true), this);
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                NativeUIComponent.aq(this.j.p.v(), 6, this.v(6), (e) => {
                    let f = e;
                    this.fb(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(2);
                this.fb(d, a, e, b, c);
            }
        }
        ee() {
            if (this.e6 != null) {
                this.e6.c = this.l;
            }
        }
        d8(a, b, c) {
            super.d8(a, b, c);
            switch (a) {
                case "IsChecked":
                    if (this.e6 != null) {
                        this.e6.bj = this.e7;
                    }
                    break;
            }
        }
        dt(a) {
            super.dt(a);
            let b = a;
            this.e8 = b.isChecked;
        }
    }
    ToolActionCheckbox.$t = /*@__PURE__*/ markType(ToolActionCheckbox, 'ToolActionCheckbox', ToolAction.$);
    return ToolActionCheckbox;
})();
/**
 * @hidden
 */
export let ToolActionNumberInput = /*@__PURE__*/ (() => {
    class ToolActionNumberInput extends ToolAction {
        constructor() {
            super(...arguments);
            this.e6 = null;
            this.e7 = 0;
        }
        get_m() {
            return 5;
        }
        get e9() {
            return this.e7;
        }
        set e9(a) {
            let b = this.e7;
            this.e7 = a;
            if (b != this.e7) {
                this.d1("Value", b, this.e7);
            }
        }
        bp() {
            return this.e8();
        }
        ba(a, b) {
            return DeviceUtils.g(70);
        }
        e8() {
            let a;
            a = NaN;
            if (this.e6 != null && ((() => { let b = tryParseNumber(this.e6.bq, a); a = b.p1; return b.ret; })())) {
            }
            return a;
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.g = this.cw;
            b.a = this.m;
            b.c = a;
            let c;
            b.e = this.e8();
            return b;
        }
        fb(a, b) {
            this.e9 = this.e8();
            let c = this.g(true);
            this.d2(c, this);
        }
        fc(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                let f = this.ba(this.j, e);
                b.bw(3, 1, f);
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                this.e6 = c;
                c.ad = f;
                c.bj = 2;
                c.bm = 1;
                c.f = 2;
                c.h = 1;
                c.bn = 1;
                c.bi = 2;
                c.bp = false;
                c.bl = runOn(this, this.fb);
            }
            c.c = this.l;
            c.bt = this.aj ? this.et : this.ex;
            c.bg = this.r;
            c.bo = this.aj;
            if (!isNaN_(this.e9)) {
                c.bq = this.e9.toString();
            }
        }
        d5(a, b, c) {
            let d = b.b;
            if (d.bo == null || (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m)) {
                NativeUIComponent.aq(this.j.p.v(), 2, this.v(2), (e) => {
                    let f = e;
                    this.fc(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(2);
                this.fc(d, a, e, b, c);
            }
        }
        ee() {
            if (this.e6 != null) {
                this.e6.c = this.l;
            }
        }
        d8(a, b, c) {
            super.d8(a, b, c);
            switch (a) {
                case "IsDisabled":
                    if (this.e6 != null) {
                        this.e6.bo = this.aj;
                        this.e6.bt = this.aj ? this.et : this.ex;
                    }
                    break;
            }
        }
        dz() {
            if (this.e6 != null && !this.aj) {
                this.e6.aw();
            }
        }
        dt(a) {
            super.dt(a);
            let b = a;
            this.e9 = b.value;
        }
    }
    ToolActionNumberInput.$t = /*@__PURE__*/ markType(ToolActionNumberInput, 'ToolActionNumberInput', ToolAction.$);
    return ToolActionNumberInput;
})();
/**
 * @hidden
 */
export let ToolActionCollection = /*@__PURE__*/ (() => {
    class ToolActionCollection extends ObservableCollection$1 {
        constructor() {
            super(ToolAction.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    ToolActionCollection.$t = /*@__PURE__*/ markType(ToolActionCollection, 'ToolActionCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(ToolAction.$));
    return ToolActionCollection;
})();
/**
 * @hidden
 */
export let Toolbar = /*@__PURE__*/ (() => {
    class Toolbar extends Base {
        constructor() {
            super();
            this.l = null;
            this.x = false;
            this.v = null;
            this.o = null;
            this.m = null;
            this.p = 0;
            this.e = new ToolActionCollection();
            this.c = new ToolActionCollection();
            this.d = new ToolActionCollection();
            this.i = Toolbar.j;
            this.r = null;
            this.ay = Toolbar.az;
            this.cm = null;
            this.cu = null;
            this.co = null;
            this.ct = null;
            this.cq = null;
            this.cv = null;
            this.cn = null;
            this.cp = null;
            this.cx = null;
            this.cw = null;
            this.am = NaN;
            this.an = NaN;
            this.cr = null;
            this.cs = null;
            this.s = null;
            this.aj = NaN;
            this.ak = NaN;
            this.al = NaN;
            this.ai = NaN;
            this.af = NaN;
            this.ag = NaN;
            this.ah = NaN;
            this.ae = NaN;
            this.aa = true;
            this.z = false;
            this.y = false;
            this.propertyChanged = null;
            this.a = null;
            this.onCommand = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.bz));
            let b = this.actualActions;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.b1));
            let c = this.actualActions;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.b2));
            NativeUIInputsFactory.n();
            NativeUIXInputsFactory.j();
            let d = new ToolbarView();
            d.a = this;
            this.l = d;
            this.l.v();
        }
        get w() {
            if (this.v == null) {
                this.v = new SRProvider(this.l.i);
                this.v.cb("Layouts");
            }
            return this.v;
        }
        b7(a) {
            this.o = a;
            this.o.bo = this;
            this.o.r = this.p == 0 ? 1 : this.p;
            let b = this.o;
            b.onCommand = delegateCombine(b.onCommand, runOn(this, this.by));
            this.o.o = this.k;
            this.o.ac = this.ad;
            this.o.fi = this.c7;
            this.o.e9 = this.cz;
            this.o.e8 = this.cy;
            this.o.fh = this.c6;
            this.o.fa = this.c0;
            this.o.fc = this.c1;
            this.o.fg = this.c5;
            this.o.fd = this.c2;
            this.o.fk = this.c9;
            this.o.fj = this.c8;
            this.o.bl = this.aw;
            this.o.bm = this.ax;
            this.o.fe = this.c3;
            this.o.ff = this.c4;
            this.o.be = this.ap;
            this.o.bf = this.aq;
            this.o.bg = this.ar;
            this.o.bd = this.ao;
            this.o.bi = this.at;
            this.o.bj = this.au;
            this.o.bk = this.av;
            this.o.bh = this.as;
        }
        by(a, b) {
            let c = false;
            if (this.r != null) {
                if (this.r.onToolCommandExecuting(b.a) == 2) {
                    c = true;
                    this.m = b;
                }
            }
            if (this.onCommand != null && !c) {
                this.onCommand(this, b);
            }
        }
        cd(a) {
            if (this.onCommand != null) {
                this.onCommand(this, this.m);
                this.m = null;
            }
        }
        ca(a) {
            this.o.notifySizeChanged();
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.cb("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get autoGeneratedActions() {
            return this.e;
        }
        set autoGeneratedActions(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.cb("AutoGeneratedActions", b, this.e);
            }
        }
        get actions() {
            return this.c;
        }
        set actions(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.cb("Actions", b, this.c);
            }
        }
        get actualActions() {
            return this.d;
        }
        set actualActions(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.cb("ActualActions", b, this.d);
            }
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.cb("Orientation", enumGetBox(ToolbarOrientation_$type, b), enumGetBox(ToolbarOrientation_$type, a));
            }
        }
        get target() {
            return this.ay;
        }
        set target(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.cb("Target", b, a);
            }
        }
        get cy() {
            return this.cm;
        }
        set cy(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.cb("BackgroundColor", b, a);
            }
        }
        get c6() {
            return this.cu;
        }
        set c6(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.cb("SubmenuBackgroundColor", b, this.cu);
            }
        }
        get c0() {
            return this.co;
        }
        set c0(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.cb("GroupHeaderBackgroundColorPropertyName", b, this.co);
            }
        }
        get c5() {
            return this.ct;
        }
        set c5(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.cb("SeparatorBackgroundColor", b, this.ct);
            }
        }
        get c2() {
            return this.cq;
        }
        set c2(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.cb("HoverBackgroundColor", b, this.cq);
            }
        }
        get c7() {
            return this.cv;
        }
        set c7(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.cb("TextColor", b, this.cv);
            }
        }
        get cz() {
            return this.cn;
        }
        set cz(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.cb("DisabledTextColor", b, this.cn);
            }
        }
        get c1() {
            return this.cp;
        }
        set c1(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.cb("GroupHeaderTextColor", b, this.cp);
            }
        }
        get c9() {
            return this.cx;
        }
        set c9(a) {
            let b = this.cx;
            this.cx = a;
            if (b != this.cx) {
                this.cb("ToolTipTextColor", b, this.cx);
            }
        }
        get c8() {
            return this.cw;
        }
        set c8(a) {
            let b = this.cw;
            this.cw = a;
            if (b != this.cw) {
                this.cb("ToolTipBackgroundColor", b, this.cw);
            }
        }
        get aw() {
            return this.am;
        }
        set aw(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.cb("ToolTipCornerRadius", b, this.am);
            }
        }
        get ax() {
            return this.an;
        }
        set ax(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.cb("ToolTipElevation", b, this.an);
            }
        }
        get c3() {
            return this.cr;
        }
        set c3(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.cb("IconFill", b, this.cr);
            }
        }
        get c4() {
            return this.cs;
        }
        set c4(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.cb("IconStroke", b, this.cs);
            }
        }
        get t() {
            return this.s;
        }
        set t(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.cb("CellTextStyle", b, this.s);
            }
        }
        u() {
            if (this.t == null) {
                return this.l.d();
            }
            return this.t;
        }
        get at() {
            return this.aj;
        }
        set at(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.cb("SeparatorVerticalPaddingLeft", b, this.aj);
            }
        }
        get au() {
            return this.ak;
        }
        set au(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.cb("SeparatorVerticalPaddingRight", b, this.ak);
            }
        }
        get av() {
            return this.al;
        }
        set av(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.cb("SeparatorVerticalPaddingTop", b, this.al);
            }
        }
        get as() {
            return this.ai;
        }
        set as(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.cb("SeparatorVerticalPaddingBottom", b, this.ai);
            }
        }
        get ap() {
            return this.af;
        }
        set ap(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.cb("SeparatorHorizontalPaddingLeft", b, this.af);
            }
        }
        get aq() {
            return this.ag;
        }
        set aq(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.cb("SeparatorHorizontalPaddingRight", b, this.ag);
            }
        }
        get ar() {
            return this.ah;
        }
        set ar(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.cb("SeparatorHorizontalPaddingTop", b, this.ah);
            }
        }
        get ao() {
            return this.ae;
        }
        set ao(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.cb("SeparatorHorizontalPaddingBottom", b, this.ae);
            }
        }
        get ad() {
            return this.aa;
        }
        set ad(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.cb("ShowOnHover", b, this.aa);
            }
        }
        bz(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b0));
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.b0));
                    }
                }
            }
            this.b9();
        }
        b1(a, b) {
            this.cl();
        }
        b2(a, b) {
            for (let c = 0; c < this.actualActions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actualActions._inner[c]) !== null) {
                    let d = this.actualActions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b0));
                }
                this.actualActions._inner[c].b = null;
            }
        }
        cl() {
            let a = this.q == 0 ? 1 : this.q;
            if (this.o != null) {
                this.o.r = a;
            }
            for (let b = 0; b < this.actualActions.count; b++) {
                this.actualActions._inner[b].l = a;
            }
        }
        b0(a, b) {
        }
        b9() {
            this.cg();
        }
        cg() {
            if (this.y) {
                return;
            }
            if (this.b != null) {
                this.y = true;
                this.b.enqueueAction(runOn(this, this.b5));
            }
            else {
                this.z = true;
            }
        }
        b5() {
            if (!this.y) {
                return;
            }
            this.y = false;
            this.ch();
            if (this.o.actions != this.actualActions) {
                this.o.actions = this.actualActions;
            }
        }
        ch() {
            this.actualActions.clear();
            for (let a = 0; a < this.autoGeneratedActions.count; a++) {
                this.actualActions.add(this.autoGeneratedActions._inner[a]);
            }
            let b = null;
            let c = null;
            let d = false;
            let e = false;
            let f = -1;
            let g = 0;
            for (let h = 0; h < this.actions.count; h++) {
                let i = this.actions._inner[h];
                if (!stringIsNullOrEmpty(i.c0)) {
                    if (((() => { let j = this.ab(i.c0, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        b._inner[f].d7(i);
                    }
                }
                else {
                    if (!stringIsNullOrEmpty(i.cc)) {
                        if (i.d != null) {
                            i.d.actions.remove(i);
                        }
                        if (((() => { let j = this.ab(i.cc, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.cc;
                            d = true;
                            e = false;
                        }
                    }
                    else if (!stringIsNullOrEmpty(i.b9)) {
                        if (i.d != null) {
                            i.d.actions.remove(i);
                        }
                        if (((() => { let j = this.ab(i.b9, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.b9;
                            d = false;
                            e = true;
                            g = 0;
                        }
                    }
                    if (!stringIsNullOrEmpty(c)) {
                        if (d) {
                            b.insert(f, i);
                            f++;
                        }
                        else if (e) {
                            b.insert(f + 1 + g, i);
                            g++;
                        }
                    }
                    else {
                        this.actualActions.add(i);
                    }
                }
            }
        }
        ab(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.cy != null && f.cy == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.ab(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        ac(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.ch == null) {
                    if (f.cy != null && f.cy == a) {
                        c = b;
                        d = e;
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
                else if (f.ch != null && f.ch == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.ab(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        b6() {
            if (this.y) {
                this.b5();
            }
        }
        notifySizeChanged() {
            this.l.s();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.l.t(a);
        }
        cb(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ce(a, b, c);
        }
        ce(a, b, c) {
            switch (a) {
                case "CellTextStyle":
                    this.cg();
                    break;
                case "BackgroundColor":
                case "TextColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderBackgroundColorPropertyName":
                case "GroupHeaderTextColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "Orientation":
                case "ShowOnHover":
                    this.ck();
                    break;
                case "Target":
                    let d = c;
                    let e = b;
                    this.cc(e, d);
                    break;
                case "BaseTheme":
                    this.cl();
                    break;
                case "ExecutionContext":
                    if (this.b != null && this.z) {
                        this.cg();
                        this.z = false;
                    }
                    break;
            }
        }
        ck() {
            if (this.o != null) {
                this.o.ac = this.ad;
                this.o.e8 = this.cy;
                this.o.fi = this.c7;
                this.o.e9 = this.cz;
                this.o.fh = this.c6;
                this.o.fa = this.c0;
                this.o.fc = this.c1;
                this.o.fg = this.c5;
                this.o.fd = this.c2;
                this.o.o = this.k;
                this.o.fk = this.c9;
                this.o.fj = this.c8;
                this.o.bl = this.aw;
                this.o.bm = this.ax;
                this.o.fe = this.c3;
                this.o.ff = this.c4;
                this.o.be = this.ap;
                this.o.bf = this.aq;
                this.o.bg = this.ar;
                this.o.bd = this.ao;
                this.o.bi = this.at;
                this.o.bj = this.au;
                this.o.bk = this.av;
                this.o.bh = this.as;
            }
        }
        cc(a, b) {
            this.r = b;
            if (a != null) {
                a.commandCompleted = null;
                this.autoGeneratedActions.clear();
                a.removeCommandStateChangedListener(this);
                this.cg();
            }
            if (b != null) {
                b.commandCompleted = runOn(this, this.cd);
                this.autoGeneratedActions.clear();
                let c = b.getDesiredToolbarActions();
                if (c != null) {
                    for (let d = 0; d < c.length; d++) {
                        let e = ToolAction.c(c[d]);
                        this.autoGeneratedActions.add(e);
                    }
                }
                b.addCommandStateChangedListener(this);
                this.cg();
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.cb("ExecutionContext", b, this.a);
            }
        }
        b3() {
            if (this.o != null) {
                this.o.dd();
            }
        }
        onCommandStateChanged(a, b, c) {
            let d = null;
            let e = -1;
            if (((() => { let f = this.ac(a, this.actualActions, d, e); d = f.p2; e = f.p3; return f.ret; })())) {
                let f = d._inner[e];
                switch (b) {
                    case 2:
                        switch (f.m) {
                            case 2:
                                f.e8 = c;
                                break;
                            case 5:
                                f.e9 = c;
                                break;
                            case 6:
                                f.e8 = c;
                                break;
                        }
                        break;
                    case 0:
                        f.e5 = EnumUtil.getEnumValue(Visibility_$type, c);
                        break;
                    case 1:
                        f.aj = c;
                        break;
                }
            }
        }
        ci(a, b) {
            for (let c = 0; c < a.count; c++) {
                let d = a._inner[c];
                if (d.cp == b) {
                    d.cp = null;
                    d.cp = b;
                }
                if (d.actions != null && d.actions.count > 0) {
                    this.ci(d.actions, b);
                }
            }
        }
        cj(a, b, c) {
            SvgIconRegistry.instance.addSvgPathString(a, b, c);
            this.ci(this.actualActions, b);
        }
        ba(a, b) {
            return SvgIconRegistry.instance.getSvgPathString(a, b);
        }
    }
    Toolbar.$t = /*@__PURE__*/ markType(Toolbar, 'Toolbar', Base.$, [INotifyPropertyChanged_$type, ICommandStateChangedListener_$type]);
    Toolbar.j = 1;
    Toolbar.az = null;
    return Toolbar;
})();
/**
 * @hidden
 */
export let ToolPanel = /*@__PURE__*/ (() => {
    class ToolPanel extends Base {
        get x() {
            if (this.w == null) {
                this.w = new SRProvider(this.p.n);
                this.w.cb("Layouts");
            }
            return this.w;
        }
        di(a) {
            this.d = a;
            let b = this.d;
            b.rowUpdating = delegateCombine(b.rowUpdating, runOn(this, this.c8));
            let c = this.d;
            c.contentRefreshed = delegateCombine(c.contentRefreshed, runOn(this, this.c5));
            this.d.k = this.o;
            this.d.ai = true;
            let d = this.d;
            d.itemHeightRequested = delegateCombine(d.itemHeightRequested, runOn(this, this.c6));
            let e = this.d;
            e.itemWidthRequested = delegateCombine(e.itemWidthRequested, runOn(this, this.c7));
        }
        c5(a, b) {
            if (this.contentRefreshed != null) {
                this.contentRefreshed(this, new ToolPanelContentRefreshedEventArgs());
            }
        }
        c6(a, b) {
            let c = b.c;
            let d = new ToolActionMeasurementContext();
            this.dr(d);
            c.dm(this, d);
            if (c.e5 == 0) {
                if (!isNaN_(d.d)) {
                    b.a = d.d;
                }
                else {
                    b.a = this.d.av;
                }
            }
            else {
                b.a = 0;
            }
        }
        c7(a, b) {
            let c = b.c;
            let d = new ToolActionMeasurementContext();
            this.dr(d);
            c.dm(this, d);
            if (c.e5 == 0) {
                if (!isNaN_(d.e)) {
                    b.a = d.e;
                }
            }
            else {
                b.a = 0;
            }
        }
        c8(a, b) {
            let c = b.a.o;
            let d = a;
            if (this.o == 1) {
                let e = new ToolActionMeasurementContext();
                this.dr(e);
                c.dm(this, e);
                c.d3(d, this, b, e);
            }
            else {
                c.d3(d, this, b, this.i);
            }
        }
        dn(a) {
            this.ar = a.width;
            this.dv();
            this.d.notifySizeChanged();
        }
        get actions() {
            return this.g;
        }
        set actions(a) {
            let b = this.g;
            this.g = a;
            if (b != this.g) {
                this.dp("Actions", b, this.g);
            }
        }
        get ac() {
            return this.aa;
        }
        set ac(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.dp("ShowOnHover", b, this.aa);
            }
        }
        constructor() {
            super();
            this.p = null;
            this.v = null;
            this.bo = null;
            this.y = false;
            this.w = null;
            this.i = new ToolActionMeasurementContext();
            this.propertyChanged = null;
            this.g = new ToolActionCollection();
            this.contentRefreshed = null;
            this.aa = true;
            this.z = false;
            this.ae = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
            this.af = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
            this.ad = new Dictionary$2(String_$type, ToolAction.$, 0);
            this.s = null;
            this.a = null;
            this.q = 0;
            this.ei = null;
            this.d5 = null;
            this.er = null;
            this.ee = null;
            this.ek = null;
            this.d7 = null;
            this.eq = null;
            this.ed = null;
            this.el = null;
            this.d8 = null;
            this.en = null;
            this.ea = null;
            this.d = null;
            this.ar = Number.POSITIVE_INFINITY;
            this.es = null;
            this.ef = null;
            this.ej = null;
            this.d6 = null;
            this.em = null;
            this.d9 = null;
            this.eu = null;
            this.eh = null;
            this.et = null;
            this.eg = null;
            this.a0 = NaN;
            this.ap = NaN;
            this.a1 = NaN;
            this.aq = NaN;
            this.eo = null;
            this.eb = null;
            this.ep = null;
            this.ec = null;
            this.ax = NaN;
            this.am = NaN;
            this.ay = NaN;
            this.an = NaN;
            this.az = NaN;
            this.ao = NaN;
            this.aw = NaN;
            this.al = NaN;
            this.at = NaN;
            this.ai = NaN;
            this.au = NaN;
            this.aj = NaN;
            this.av = NaN;
            this.ak = NaN;
            this.as = NaN;
            this.ah = NaN;
            this.m = ToolPanel.n;
            this.onCommand = null;
            this.e = 0;
            this.drillDownRequested = null;
            this.drillUpRequested = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.c9));
            NativeUIXInputsFactory.j();
            NativeUIInputsFactory.n();
            NativeUILayoutFactory.e();
            let b = new ToolPanelView();
            b.c = this;
            this.p = b;
            this.p.ab();
            this.d4();
        }
        c9(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.dj));
                    }
                    c.dh();
                    c.b = null;
                    c.j = null;
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.dj));
                    }
                    e.b = this.a;
                    e.j = this;
                }
            }
            this.d3(this.actions);
            this.dm();
        }
        da(a, b) {
            for (let c = 0; c < this.actions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[c]) !== null) {
                    let d = this.actions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.dj));
                }
                this.actions._inner[c].dh();
                this.actions._inner[c].b = null;
                this.actions._inner[c].j = null;
            }
        }
        dm() {
            this.dv();
        }
        dv() {
            if (this.z) {
                return;
            }
            this.z = true;
            this.a.enqueueAction(runOn(this, this.df));
        }
        dx() {
            this.z = true;
            this.df();
        }
        df() {
            if (!this.z) {
                return;
            }
            this.z = false;
            this.db();
            this.d1();
            for (let a = 0; a < this.g.count; a++) {
                this.j(this.g._inner[a]);
            }
            this.dg();
        }
        db() {
            this.ae.clear();
            this.af.clear();
            this.ad.clear();
            for (let a = 0; a < this.g.count; a++) {
                this.g._inner[a].j = this;
                if (this.g._inner[a].cw != null) {
                    this.ad.item(this.g._inner[a].cw, this.g._inner[a]);
                }
            }
            for (let b = 0; b < this.g.count; b++) {
                if (this.g._inner[b].c5 != null) {
                    if (this.ad.containsKey(this.g._inner[b].c5)) {
                        if (!this.ae.containsKey(this.g._inner[b].c5)) {
                            this.ae.item(this.g._inner[b].c5, new List$1(ToolAction.$, 0));
                        }
                        let c = this.ae.item(this.g._inner[b].c5);
                        c.add(this.g._inner[b]);
                    }
                }
            }
            for (let d = 0; d < this.g.count; d++) {
                if (this.g._inner[d].m == 6) {
                    let e = this.g._inner[d].fa;
                    if (!this.af.containsKey(e)) {
                        this.af.item(e, new List$1(ToolAction.$, 0));
                    }
                    this.af.item(e).add(this.g._inner[d]);
                }
            }
        }
        ab(a) {
            if (a.cw == null) {
                return false;
            }
            return this.ae.containsKey(a.cw);
        }
        f(a) {
            if (this.ad.containsKey(a)) {
                return this.ad.item(a);
            }
            return null;
        }
        ag(a) {
            if (a.cw == null) {
                return null;
            }
            if (this.ae.containsKey(a.cw)) {
                return this.ae.item(a.cw);
            }
            return null;
        }
        j(a) {
            let b = new ToolActionMeasurementContext();
            this.dr(b);
            a.dm(this, b);
            this.dk(this.i, b);
            return b;
        }
        dr(a) {
            a.a = this.o;
            a.c = this.ar;
        }
        dk(a, b) {
            if (!isNaN_(b.f)) {
                if (isNaN_(a.f)) {
                    a.f = b.f;
                }
                else {
                    a.f = Math.max(a.f, b.f);
                }
            }
            if (!isNaN_(b.h)) {
                if (isNaN_(a.h)) {
                    a.h = b.h;
                }
                else {
                    a.h = Math.max(a.h, b.h);
                }
            }
        }
        d1() {
            this.i = new ToolActionMeasurementContext();
            this.i.a = this.o;
            this.i.c = this.ar;
        }
        fl() {
            let a = 0;
            let b = 0;
            if (this.o == 0) {
                for (let c = 0; c < this.actions.count; c++) {
                    let d = this.j(this.actions._inner[c]);
                    a = Math.max(d.e, a);
                    if (this.actions._inner[c].e5 == 0) {
                        if (!isNaN_(d.d)) {
                            b += d.d;
                        }
                        else {
                            b += this.a2;
                        }
                    }
                }
            }
            return new Size(1, a, b);
        }
        dg() {
            if (this.d.itemsSource != this.actions) {
                this.d.itemsSource = this.actions;
            }
        }
        dh() {
            if (this.z) {
                this.df();
            }
            if (this.d != null) {
                this.d.bt();
            }
        }
        dy() {
            if (this.d != null) {
                this.d.cm();
            }
        }
        dw(a) {
            let b = a.fa;
            let c = a.cw;
            if (this.af != null) {
                if (this.af.containsKey(b)) {
                    for (let d = 0; d < this.af.item(b).count; d++) {
                        if (this.af.item(b)._inner[d].cw != c) {
                            this.af.item(b)._inner[d].fc();
                        }
                    }
                }
            }
        }
        dj(a, b) {
            this.dm();
        }
        dc() {
            for (let a = 0; a < this.actions.count; a++) {
                this.actions._inner[a].dh();
            }
        }
        ds() {
            for (let a = 0; a < this.actions.count; a++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[a]) !== null) {
                    let b = this.actions._inner[a];
                    b.propertyChanged = delegateRemove(b.propertyChanged, runOn(this, this.dj));
                }
                this.actions._inner[a].b = null;
            }
        }
        notifySizeChanged() {
            this.p.y();
        }
        destroy() {
            this.provideContainer(null);
            this.dc();
        }
        provideContainer(a) {
            this.p.z(a);
        }
        get t() {
            return this.s;
        }
        set t(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.dp("CellTextStyle", b, this.s);
            }
        }
        u() {
            if (this.t == null) {
                return this.p.f();
            }
            return this.t;
        }
        dp(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.dt(a, b, c);
        }
        dt(a, b, c) {
            switch (a) {
                case "BaseTheme":
                case "TextColor":
                case "BackgroundColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderTextColor":
                case "GroupHeaderBackgroundColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "SeparatorHorizontalPaddingLeft":
                case "SeparatorHorizontalPaddingRight":
                case "SeparatorHorizontalPaddingTop":
                case "SeparatorHorizontalPaddingBottom":
                case "SeparatorVerticalPaddingLeft":
                case "SeparatorVerticalPaddingRight":
                case "SeparatorVerticalPaddingTop":
                case "SeparatorVerticalPaddingBottom":
                    this.d4();
                    break;
                case "ActualTextColor":
                case "ActualIconFill":
                case "ActualIconStroke":
                case "ActualSubmenuBackgroundColor":
                case "ActualGroupHeaderTextColor":
                case "ActualGroupHeaderBackgroundColor":
                case "ActualSeparatorBackgroundColor":
                case "ActualHoverBackgroundColor":
                case "ActualToolTipTextColor":
                case "ActualToolTipBackgroundColor":
                case "ActualToolTipCornerRadius":
                case "ActualToolTipElevation":
                case "ActualSeparatorHorizontalPaddingLeft":
                case "ActualSeparatorHorizontalPaddingRight":
                case "ActualSeparatorHorizontalPaddingTop":
                case "ActualSeparatorHorizontalPaddingBottom":
                case "ActualSeparatorVerticalPaddingLeft":
                case "ActualSeparatorVerticalPaddingRight":
                case "ActualSeparatorVerticalPaddingTop":
                case "ActualSeparatorVerticalPaddingBottom":
                    this.d3(this.actions);
                    break;
                case "CellTextStyle":
                    this.dv();
                    break;
                case "ActualBackgroundColor":
                    this.d2();
                    break;
                case "Orientation":
                    if (this.d != null) {
                        this.d.k = this.o;
                    }
                    break;
                case "Actions":
                    if (b != null) {
                        let d = b;
                        d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.c9));
                        d.collectionResetting = delegateRemove(d.collectionResetting, runOn(this, this.da));
                        for (let e of fromEnum(d)) {
                            if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                                let f = e;
                                f.propertyChanged = delegateRemove(f.propertyChanged, runOn(this, this.dj));
                            }
                            e.b = null;
                            e.j = null;
                        }
                    }
                    if (c != null) {
                        let g = c;
                        g.collectionChanged = delegateCombine(g.collectionChanged, runOn(this, this.c9));
                        g.collectionResetting = delegateCombine(g.collectionResetting, runOn(this, this.da));
                        for (let h of fromEnum(g)) {
                            if (typeCast(INotifyPropertyChanged_$type, h) !== null) {
                                let i = h;
                                i.propertyChanged = delegateCombine(i.propertyChanged, runOn(this, this.dj));
                            }
                            h.b = this.a;
                            h.j = this;
                        }
                    }
                    this.d3(this.actions);
                    this.dv();
                    break;
            }
        }
        d4() {
            switch (this.r) {
                case 0:
                case 1:
                case 2:
                case 5:
                case 3:
                    this.e5 = this.fi != null ? this.fi : BrushUtil.g(255, 24, 29, 31);
                    this.ew = this.e9 != null ? this.e9 : BrushUtil.g(102, 0, 0, 0);
                    this.ev = this.e8 != null ? this.e8 : BrushUtil.g(255, 255, 255, 255);
                    this.e4 = this.fh != null ? this.fh : BrushUtil.g(255, 255, 255, 255);
                    this.ex = this.fa != null ? this.fa : BrushUtil.g(255, 237, 239, 245);
                    this.ez = this.fc != null ? this.fc : BrushUtil.g(255, 142, 143, 147);
                    this.e3 = this.fg != null ? this.fg : BrushUtil.g(255, 237, 239, 245);
                    this.ey = this.fb != null ? this.fb : BrushUtil.g(25, 0, 0, 0);
                    this.e0 = this.fd != null ? this.fd : BrushUtil.g(51, 178, 191, 220);
                    this.e7 = this.fk != null ? this.fk : BrushUtil.g(255, 0, 0, 0);
                    this.e1 = this.fe != null ? this.fe : BrushUtil.g(255, 0, 0, 0);
                    this.e2 = this.ff != null ? this.ff : BrushUtil.g(255, 0, 0, 0);
                    this.e6 = this.fj != null ? this.fj : BrushUtil.g(255, 237, 239, 245);
                    this.bb = !isNaN_(this.bl) ? this.bl : 8;
                    this.bc = !isNaN_(this.bm) ? this.bm : 4;
                    this.a8 = !isNaN_(this.bi) ? this.bi : 0;
                    this.a9 = !isNaN_(this.bj) ? this.bj : 0;
                    this.ba = !isNaN_(this.bk) ? this.bk : 0;
                    this.a7 = !isNaN_(this.bh) ? this.bh : 0;
                    this.a4 = !isNaN_(this.be) ? this.be : 0;
                    this.a5 = !isNaN_(this.bf) ? this.bf : 0;
                    this.a6 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(10);
                    this.a3 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(10);
                    break;
                case 6:
                case 4:
                    this.e5 = this.fi != null ? this.fi : BrushUtil.g(255, 255, 255, 255);
                    this.ew = this.e9 != null ? this.e9 : BrushUtil.g(102, 255, 255, 255);
                    this.ev = this.e8 != null ? this.e8 : BrushUtil.g(255, 55, 63, 86);
                    this.e4 = this.fh != null ? this.fh : BrushUtil.g(255, 55, 63, 86);
                    this.ex = this.fa != null ? this.fa : BrushUtil.g(255, 44, 50, 70);
                    this.ez = this.fc != null ? this.fc : BrushUtil.g(255, 255, 255, 255);
                    this.e3 = this.fg != null ? this.fg : BrushUtil.g(255, 44, 50, 70);
                    this.ey = this.fb != null ? this.fb : BrushUtil.g(25, 0, 0, 0);
                    this.e0 = this.fd != null ? this.fd : BrushUtil.g(25, 105, 136, 255);
                    this.e7 = this.fk != null ? this.fk : BrushUtil.g(255, 255, 255, 255);
                    this.e1 = this.fe != null ? this.fe : BrushUtil.g(255, 210, 212, 216);
                    this.e2 = this.ff != null ? this.ff : BrushUtil.g(255, 210, 212, 216);
                    this.e6 = this.fj != null ? this.fj : BrushUtil.g(255, 44, 50, 70);
                    this.bb = !isNaN_(this.bl) ? this.bl : 8;
                    this.bc = !isNaN_(this.bm) ? this.bm : 4;
                    this.a8 = !isNaN_(this.bi) ? this.bi : 0;
                    this.a9 = !isNaN_(this.bj) ? this.bj : 0;
                    this.ba = !isNaN_(this.bk) ? this.bk : 0;
                    this.a7 = !isNaN_(this.bh) ? this.bh : 0;
                    this.a4 = !isNaN_(this.be) ? this.be : 0;
                    this.a5 = !isNaN_(this.bf) ? this.bf : 0;
                    this.a6 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(10);
                    this.a3 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(10);
                    break;
            }
        }
        d3(a) {
            for (let b = 0; b < a.count; b++) {
                a._inner[b].ed();
                this.d3(a._inner[b].actions);
            }
        }
        d2() {
            if (this.p.n != null) {
                NativeUI.l(this.p.t, this.ev);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.dp("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get e8() {
            return this.ei;
        }
        set e8(a) {
            let b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.dp("BackgroundColor", b, a);
            }
        }
        get ev() {
            return this.d5;
        }
        set ev(a) {
            let b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.dp("ActualBackgroundColor", b, this.d5);
            }
        }
        get fh() {
            return this.er;
        }
        set fh(a) {
            let b = this.er;
            this.er = a;
            if (b != this.er) {
                this.dp("SubmenuBackgroundColor", b, this.er);
            }
        }
        get e4() {
            return this.ee;
        }
        set e4(a) {
            let b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.dp("ActualSubmenuBackgroundColor", b, this.ee);
            }
        }
        get fa() {
            return this.ek;
        }
        set fa(a) {
            let b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.dp("GroupHeaderBackgroundColor", b, this.ek);
            }
        }
        get ex() {
            return this.d7;
        }
        set ex(a) {
            let b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.dp("ActualGroupHeaderBackgroundColor", b, this.d7);
            }
        }
        get fg() {
            return this.eq;
        }
        set fg(a) {
            let b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.dp("SeparatorBackgroundColor", b, this.eq);
            }
        }
        get e3() {
            return this.ed;
        }
        set e3(a) {
            let b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.dp("ActualSeparatorBackgroundColor", b, this.ed);
            }
        }
        get fb() {
            return this.el;
        }
        set fb(a) {
            let b = this.el;
            this.el = a;
            if (b != this.el) {
                this.dp("GroupHeaderSeparatorBackgroundColor", b, this.el);
            }
        }
        get ey() {
            return this.d8;
        }
        set ey(a) {
            let b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.dp(ToolPanel.bt, b, this.d8);
            }
        }
        get fd() {
            return this.en;
        }
        set fd(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.dp("HoverBackgroundColor", b, this.en);
            }
        }
        get e0() {
            return this.ea;
        }
        set e0(a) {
            let b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.dp("ActualHoverBackgroundColor", b, this.ea);
            }
        }
        get fi() {
            return this.es;
        }
        set fi(a) {
            let b = this.es;
            this.es = a;
            if (b != this.es) {
                this.dp("TextColor", b, this.es);
            }
        }
        get e5() {
            return this.ef;
        }
        set e5(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.dp("ActualTextColor", b, this.ef);
            }
        }
        get e9() {
            return this.ej;
        }
        set e9(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.dp("DisabledTextColor", b, this.ej);
            }
        }
        get ew() {
            return this.d6;
        }
        set ew(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.dp("ActualDisabledTextColor", b, this.d6);
            }
        }
        get fc() {
            return this.em;
        }
        set fc(a) {
            let b = this.em;
            this.em = a;
            if (b != this.em) {
                this.dp("GroupHeaderTextColor", b, this.em);
            }
        }
        get ez() {
            return this.d9;
        }
        set ez(a) {
            let b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.dp("ActualGroupHeaderTextColor", b, this.d9);
            }
        }
        get fk() {
            return this.eu;
        }
        set fk(a) {
            let b = this.eu;
            this.eu = a;
            if (b != this.eu) {
                this.dp("ToolTipTextColor", b, this.eu);
            }
        }
        get e7() {
            return this.eh;
        }
        set e7(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.dp("ActualToolTipTextColor", b, this.eh);
            }
        }
        get fj() {
            return this.et;
        }
        set fj(a) {
            let b = this.et;
            this.et = a;
            if (b != this.et) {
                this.dp("ToolTipBackgroundColor", b, this.et);
            }
        }
        get e6() {
            return this.eg;
        }
        set e6(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.dp("ActualToolTipBackgroundColor", b, this.eg);
            }
        }
        get bl() {
            return this.a0;
        }
        set bl(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.dp("ToolTipCornerRadius", b, this.a0);
            }
        }
        get bb() {
            return this.ap;
        }
        set bb(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.dp("ActualToolTipCornerRadius", b, this.ap);
            }
        }
        get bm() {
            return this.a1;
        }
        set bm(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.dp("ToolTipElevation", b, this.a1);
            }
        }
        get bc() {
            return this.aq;
        }
        set bc(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.dp("ActualToolTipElevation", b, this.aq);
            }
        }
        get fe() {
            return this.eo;
        }
        set fe(a) {
            let b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.dp("IconFill", b, this.eo);
            }
        }
        get e1() {
            return this.eb;
        }
        set e1(a) {
            let b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.dp("ActualIconFill", b, this.eb);
            }
        }
        get ff() {
            return this.ep;
        }
        set ff(a) {
            let b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.dp("IconStroke", b, this.ep);
            }
        }
        get e2() {
            return this.ec;
        }
        set e2(a) {
            let b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.dp("ActualIconStroke", b, this.ec);
            }
        }
        get bi() {
            return this.ax;
        }
        set bi(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.dp("SeparatorVerticalPaddingLeft", b, this.ax);
            }
        }
        get a8() {
            return this.am;
        }
        set a8(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.dp("ActualSeparatorVerticalPaddingLeft", b, this.am);
            }
        }
        get bj() {
            return this.ay;
        }
        set bj(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.dp("SeparatorVerticalPaddingRight", b, this.ay);
            }
        }
        get a9() {
            return this.an;
        }
        set a9(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.dp("ActualSeparatorVerticalPaddingRight", b, this.an);
            }
        }
        get bk() {
            return this.az;
        }
        set bk(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.dp("SeparatorVerticalPaddingTop", b, this.az);
            }
        }
        get ba() {
            return this.ao;
        }
        set ba(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.dp("ActualSeparatorVerticalPaddingTop", b, this.ao);
            }
        }
        get bh() {
            return this.aw;
        }
        set bh(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.dp("SeparatorVerticalPaddingBottom", b, this.aw);
            }
        }
        get a7() {
            return this.al;
        }
        set a7(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.dp("ActualSeparatorVerticalPaddingBottom", b, this.al);
            }
        }
        get be() {
            return this.at;
        }
        set be(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.dp("SeparatorHorizontalPaddingLeft", b, this.at);
            }
        }
        get a4() {
            return this.ai;
        }
        set a4(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.dp("ActualSeparatorHorizontalPaddingLeft", b, this.ai);
            }
        }
        get bf() {
            return this.au;
        }
        set bf(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.dp("SeparatorHorizontalPaddingRight", b, this.au);
            }
        }
        get a5() {
            return this.aj;
        }
        set a5(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.dp("ActualSeparatorHorizontalPaddingRight", b, this.aj);
            }
        }
        get bg() {
            return this.av;
        }
        set bg(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.dp("SeparatorHorizontalPaddingTop", b, this.av);
            }
        }
        get a6() {
            return this.ak;
        }
        set a6(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.dp("ActualSeparatorHorizontalPaddingTop", b, this.ak);
            }
        }
        get bd() {
            return this.as;
        }
        set bd(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.dp("SeparatorHorizontalPaddingBottom", b, this.as);
            }
        }
        get a3() {
            return this.ah;
        }
        set a3(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.dp("ActualSeparatorHorizontalPaddingBottom", b, this.ah);
            }
        }
        get o() {
            return this.m;
        }
        set o(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.dp("Orientation", enumGetBox(ToolPanelOrientation_$type, b), enumGetBox(ToolPanelOrientation_$type, a));
            }
        }
        dq(a, b) {
            if (this.onCommand != null) {
                this.onCommand(this, b);
            }
            if (a.m == 6) {
                this.dw(a);
            }
        }
        get bn() {
            return this.d.a7;
        }
        set bn(a) {
            this.d.a7 = a;
        }
        get a2() {
            return this.d.av;
        }
        dz(a) {
            if (this.drillDownRequested != null) {
                this.drillDownRequested(this, ((() => {
                    let $ret = new DrillDownRequestedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        d0(a) {
            if (this.drillUpRequested != null) {
                this.drillUpRequested(this, ((() => {
                    let $ret = new DrillDownRequestedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        dd() {
            for (let a = 0; a < this.actions.count; a++) {
                this.actions._inner[a].dj();
            }
        }
    }
    ToolPanel.$t = /*@__PURE__*/ markType(ToolPanel, 'ToolPanel', Base.$, [INotifyPropertyChanged_$type]);
    ToolPanel.bt = "ActualGroupHeaderSeparatorBackgroundColor";
    ToolPanel.n = 0;
    return ToolPanel;
})();
/**
 * @hidden
 */
export let DrillDownRequestedEventArgs = /*@__PURE__*/ (() => {
    class DrillDownRequestedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    DrillDownRequestedEventArgs.$t = /*@__PURE__*/ markType(DrillDownRequestedEventArgs, 'DrillDownRequestedEventArgs');
    return DrillDownRequestedEventArgs;
})();
/**
 * @hidden
 */
export let ToolPanelsPresenter = /*@__PURE__*/ (() => {
    class ToolPanelsPresenter extends Base {
        get a0() {
            return this.ay;
        }
        set a0(a) {
            this.d.d = this.ay = a;
        }
        get a1() {
            return this.az;
        }
        set a1(a) {
            this.g.d = this.az = a;
        }
        get v() {
            return this.u;
        }
        get n() {
            return this.m;
        }
        set n(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.as("Theme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.m));
            }
        }
        get z() {
            return this.x;
        }
        set z(a) {
            this.x = a;
        }
        constructor(a, b) {
            super();
            this.ab = null;
            this.i = null;
            this.j = null;
            this.y = 0;
            this.o = null;
            this.a = null;
            this.d = null;
            this.g = null;
            this.ay = null;
            this.az = null;
            this.p = null;
            this.b = null;
            this.e = null;
            this.h = null;
            this.c = null;
            this.f = null;
            this.w = new Queue$1(PanelAnimationRequest.$);
            this.r = null;
            this.q = null;
            this.u = new List$1(PanelInfo.$, 0);
            this.m = 1;
            this.x = 200;
            this.s = null;
            this.aa = 0;
            this.t = false;
            this.containerReady = null;
            this.sizeChanged = null;
            this.propertyChanged = null;
            this.ab = a;
            this.i = b;
        }
        ai(a) {
            NativeUIComponent.at(this.ab, [7, 9], (b) => {
                this.r = b[0];
                this.q = b[1];
                this.r.bj(this.q);
                this.q.a9 = new MatrixTransform();
                if (a != null) {
                    a();
                }
            });
        }
        a2() {
            if (this.j != null) {
                return this.j.f();
            }
            return this.r.bb(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        ae(a, b = null) {
            for (let c = 0; c < this.v.count; c++) {
                if (this.v._inner[c].b == a) {
                    if (b != null) {
                        b(this.v._inner[c].a);
                    }
                    return;
                }
            }
            NativeUIComponent.ar(this.ab, 13, (d) => {
                let e = d;
                e.c = this.n;
                e.b1 = a.j.fi;
                e.bw = a.j.e9;
                e.bv = a.j.fh;
                e.b0 = a.j.fh;
                e.bx = a.j.fa;
                e.by = a.j.fc;
                e.bz = a.j.fg;
                e.bp = a.actions;
                e.bi = runOn(this, this.aq);
                e.bj = runOn(this, this.ar);
                e.bo = runOn(this, this.ao);
                this.q.bj(e);
                this.y = 0;
                for (let f = 0; f < this.v.count; f++) {
                    let g = this.v._inner[f].f();
                    this.y += g.width;
                    this.v._inner[f].a.ad = g.width;
                }
                this.q.bq(e, this.y);
                this.q.br(e, 0);
                this.v.add(new PanelInfo(a, e, this.y));
                this.av();
                if (b != null) {
                    b(e);
                }
            });
        }
        aj(a) {
            for (let b = 0; b < this.v.count; b++) {
                if (this.v._inner[b].a == a) {
                    this.al(b);
                }
            }
        }
        al(a) {
            this.ak(this.v._inner[a]);
        }
        ak(a, b = null) {
            this.af(a, -Math.floor(a.c), b);
            this.j = a;
        }
        aq(a, b) {
            this.aa++;
            if (this.v.count > 1 && this.aa < this.v.count) {
                for (let c = this.v.count - 1; c > this.aa; c--) {
                    this.v._inner[c].a.bi = null;
                    this.v._inner[c].a.bj = null;
                    this.q.bl(this.v._inner[c].a);
                    this.y -= this.v._inner[c].a.ad;
                    this.v.removeAt(c);
                }
                if (this.v._inner[this.aa].b == b.a) {
                    this.aj(this.v._inner[this.aa].a);
                    return;
                }
                else {
                    this.v._inner[this.aa].a.bi = null;
                    this.v._inner[this.aa].a.bj = null;
                    this.q.bl(this.v._inner[this.aa].a);
                    this.y -= this.v._inner[this.aa].a.ad;
                    this.v.removeAt(this.aa);
                }
            }
            this.ae(b.a, (d) => this.i.executeDelayed(() => this.aj(d), 0));
        }
        ar(a, b) {
            this.aa--;
            this.ak(this.v._inner[this.v.count - 2], () => {
            });
        }
        ao(a, b) {
            if (this.s != null) {
                this.s(b);
            }
        }
        af(a, b, c = null) {
            this.ah();
            if (this.q.a9 == null) {
                let d = a.f();
                this.r.ad = Math.floor(d.width);
                this.r.x = Math.floor(d.height);
                return;
            }
            if (this.o.playState == 1) {
                if ((this.o.playbackRate > 0 && this.a0.j == b) || (this.o.playbackRate < 0 && this.a1.j == b)) {
                    this.o.reverse();
                    this.p.reverse();
                }
                else {
                    this.w.g(((() => {
                        let $ret = new PanelAnimationRequest();
                        $ret.a = a;
                        $ret.c = b;
                        $ret.b = c;
                        return $ret;
                    })()));
                }
            }
            else {
                this.a0 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = this.a1.j;
                    return $ret;
                })());
                this.a1 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = b;
                    return $ret;
                })());
                let e = a.f();
                this.e.d = this.r.ad;
                this.c.d = this.r.x;
                this.h.d = Math.floor(e.width);
                this.f.d = Math.floor(e.height);
                this.o.updatePlaybackRate(1);
                this.o.play();
                this.o.finished.f((f) => this.an(c));
                this.p.updatePlaybackRate(1);
                this.p.play();
                this.p.finished.f((f) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                });
            }
        }
        ah() {
            if (this.o == null) {
                let a = new AnimationKeyFrameEffectTiming();
                a.g = this.z;
                a.b = 0;
                this.a = new AnimationKeyFrameEffect(0, this.q.al, 0, null, a);
                this.ay = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = 0;
                    return $ret;
                })());
                this.az = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = 0;
                    return $ret;
                })());
                this.d = new AnimationKeyFrameProperty(14, this.ay);
                this.g = new AnimationKeyFrameProperty(14, this.az);
                this.o = KeyFrameAnimationFactory.f.c(this.a.m(this.d).m(this.g));
                this.b = new AnimationKeyFrameEffect(0, this.r.al, 0, null, a);
                this.e = new AnimationKeyFrameProperty(9, 0);
                this.c = new AnimationKeyFrameProperty(10, 0);
                this.h = new AnimationKeyFrameProperty(9, 0);
                this.f = new AnimationKeyFrameProperty(10, 0);
                this.p = KeyFrameAnimationFactory.f.c(this.b.m(this.e, this.c).m(this.h, this.f));
            }
        }
        an(a) {
            if (this.o != null) {
                this.o.commitStyles();
            }
            if (a != null) {
                a();
            }
            if (this.o.playbackRate < 0) {
                let b = this.a1.j;
                this.a1 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = this.a0.j;
                    return $ret;
                })());
                this.a0 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = b;
                    return $ret;
                })());
            }
            if (this.w.count > 0) {
                let c = this.w.b();
                this.ak(c.a, c.b);
            }
        }
        av() {
            if (this.t) {
                return;
            }
            this.t = true;
            this.i.enqueueAction(runOn(this, this.ag));
        }
        ag() {
            if (!this.t) {
                return;
            }
            this.t = false;
            for (let a = 0; a < this.v.count; a++) {
                this.v._inner[a].e();
                let b = this.v._inner[a].f();
                this.v._inner[a].a.ad = b.width;
                this.v._inner[a].a.x = b.height;
                this.v._inner[a].a.bt(b);
            }
        }
        aw() {
            this.aa = 0;
            this.q.a9 = new MatrixTransform();
            let a = this.v._inner[0].f();
            this.r.ad = Math.floor(a.width);
            this.r.x = Math.floor(a.height);
            this.ay = ((() => {
                let $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
            this.az = ((() => {
                let $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
        }
        ax(a, b) {
            this.m = a;
            for (let c = 0; c < this.v.count; c++) {
                let d = this.v._inner[c].a;
                d.c = a;
                d.b1 = b.fi;
                d.bw = b.e9;
                d.bv = b.fh;
                d.b0 = b.fh;
                d.bx = b.fa;
                d.by = b.fc;
                d.bz = b.fg;
            }
        }
        am() {
            let a = this.v._inner[0].f();
            this.v._inner[0].d(a);
        }
        ap() {
            if (this.containerReady != null) {
                this.containerReady(this);
            }
        }
        at() {
            if (this.sizeChanged != null) {
                this.sizeChanged(this);
            }
        }
        as(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.au(a, b, c);
        }
        au(a, b, c) {
            switch (a) {
                case "Theme":
                    for (let d = 0; d < this.v.count; d++) {
                        this.v._inner[d].a.c = this.n;
                    }
                    break;
            }
        }
    }
    ToolPanelsPresenter.$t = /*@__PURE__*/ markType(ToolPanelsPresenter, 'ToolPanelsPresenter', Base.$, [INotifyPropertyChanged_$type]);
    return ToolPanelsPresenter;
})();
/**
 * @hidden
 */
export let PanelInfo = /*@__PURE__*/ (() => {
    class PanelInfo extends Base {
        constructor(a, b, c) {
            super();
            this.c = 0;
            this.a = null;
            this.b = null;
            this.b = a;
            this.a = b;
            this.c = c;
        }
        f() {
            return this.a.bb(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        e() {
            this.a.bu();
        }
        d(a) {
            this.a.bt(a);
        }
    }
    PanelInfo.$t = /*@__PURE__*/ markType(PanelInfo, 'PanelInfo');
    return PanelInfo;
})();
/**
 * @hidden
 */
export let PanelAnimationRequest = /*@__PURE__*/ (() => {
    class PanelAnimationRequest extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = 0;
            this.b = null;
        }
    }
    PanelAnimationRequest.$t = /*@__PURE__*/ markType(PanelAnimationRequest, 'PanelAnimationRequest');
    return PanelAnimationRequest;
})();
