import { IgrToolAction } from "./igr-tool-action";
import { ToolActionNumberInput } from "./ToolActionNumberInput";
export class IgrToolActionNumberInput extends IgrToolAction {
    createImplementation() {
        return new ToolActionNumberInput();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the value for the input.
    */
    get value() {
        return this.i.e9;
    }
    set value(v) {
        this.i.e9 = +v;
    }
    fromInfo(info) {
        this.i.dt(info);
    }
}
